/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * d_error.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "d_error.h"
/*-----------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>

#define Uses_THistory
#define Uses_TValidate
#define Uses_TSItem
#define Uses_TRadioButtons
#define Uses_TCheckBoxes
#define Uses_TEvent
#define Uses_TKeys
#define Uses_TDeskTop
#define Uses_TButton
#define Uses_TInputLine
#define Uses_TSItem
#define Uses_TStaticText
#define Uses_TLabel
#include <tv.h>

#include "main.h"
#include "options.h"
#include "const.h"
#include "search.h"
/*-----------------------------------------------------------------*/
//              class TErrorDial : public TDialog
/*-----------------------------------------------------------------*/
TErrorDial::TErrorDial(TRect AR, char* AT, THUB* AMain)
           :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main = AMain;
  helpCtx = 20;
  
  kol = new TNSStringCollection(10, 10);

  LB = new TListBox(TRect(1,1,78,10), 1, NULL);
  insert(LB);

  kol->insert(NewStr(" "));
  dkol.items     = kol;
  dkol.selection = 0;
  LB->setData(&dkol);
  // SelectView(LB);
}
/*-----------------------------------------------------------------*/
void TErrorDial::shutDown()
{
 destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TErrorDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF4:
     case kbEnter:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TErrorDial::AddMessage(char* Message)
{
 if (strlen2(Message)<8) return;

 while (kol->getCount() > 100) {
   kol->atRemove(0);
   LB->setRange(kol->getCount());
   LB->focusItem(kol->getCount()-1);
 }

 char s[MAXMSG];
 strcpy2(s, (char*)(Message+8));
 while (strlen(s)>75) {
   char s1[81], s2[MAXMSG];
   strncpy(s1, s, 75); s1[75]='\0';
   kol->insert(NewStr(s1));
   strcpy2(s2, (char*)(s+75));
   strcpy2(s, s2);
 }
 if (strlen(s)>0) kol->insert(NewStr(s));
 LB->setRange(kol->getCount());
 LB->focusItem(kol->getCount()-1);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//               class TAutoDial : public TDialog
/*-----------------------------------------------------------------*/
TAutoDial::TAutoDial(TRect AR, char* AT, THUB* AMain)
          :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main = AMain;
  helpCtx = 20;
  
  kol = new TNSStringCollection(10,10);

  LB = new TListBox(TRect(1,1,78,10), 1, NULL);
  insert(LB);
//  Insert(new TButton(TRect(65,9,76,11),"Close",cmCancel,bfDefault));

  kol->insert(NewStr(" "));
  dkol.items     = kol;
  dkol.selection = 0;
  LB->setData(&dkol);
}
/*-----------------------------------------------------------------*/
void TAutoDial::shutDown()
{
 destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TAutoDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF2:
     case kbEnter:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TAutoDial::AddMessage(char* Message)
{
 if (strlen2(Message)<8) return;

 while (kol->getCount() > 100) {
   kol->atRemove(0);
   LB->setRange(kol->getCount());
   LB->focusItem(kol->getCount()-1);
 }
 
 // Eliminate some messages
 if (strstr(Message+8, "/REUINFO")==(Message+8)) return;

 char s[MAXMSG];
 strcpy2(s, (char*)(Message+8));
 while (strlen2(s)>75) {
   char s1[81], s2[MAXMSG];
   strncpy(s1, s, 75); s1[75]='\0';
   kol->insert(NewStr(s1));
   strcpy2(s2, (char*)(s+75));
   strcpy2(s, s2);
 }
 if (strlen(s)>0) kol->insert(NewStr(s));
 LB->setRange(kol->getCount());
 LB->focusItem(kol->getCount()-1);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//             class TOtherDial : public TDialog
/*-----------------------------------------------------------------*/
TOtherDial::TOtherDial(TRect AR, char* AT, THUB* AMain)
           :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main = AMain;
  helpCtx = 20;
  
  kol = new TNSStringCollection(10, 10);

  LB = new TListBox(TRect(1,1,78,10), 1, NULL);
  insert(LB);
//  Insert(new TButton(TRect(65,9,76,11),"Close",cmCancel,bfDefault));

  kol->insert(NewStr(" "));
  dkol.items     = kol;
  dkol.selection = 0;
  LB->setData(&dkol);
}
/*-----------------------------------------------------------------*/
void TOtherDial::shutDown()
{
 destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TOtherDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF1:
     case kbEnter:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TOtherDial::AddMessage(char* Message, bool trunc)
{
 if (strlen2(Message)<8) return;

 while (kol->getCount() > 100) {
   kol->atRemove(0);
   LB->setRange(kol->getCount());
   LB->focusItem(kol->getCount()-1);
 }

 char s[MAXMSG];
 if (trunc) strcpy2(s, (char*)(Message+8));
       else strcpy2(s, Message);

 // Eliminate some messages
 if (strstr(Message, "RFRSH]")==Message) return;

 if (strstr(Message, "GLSTB]")==Message) return;
 if (strstr(Message, "GLSTE]")==Message) return;
 if (strstr(Message, "GQLSB]")==Message) return;
 if (strstr(Message, "GQLSE]")==Message) return;

 if (strstr(Message, "PRGBR]")==Message) return;

 if (strstr(Message, "$LS~ ]")==Message) return;
 if (strstr(Message, "$LS+ ]")==Message) return;
 if (strstr(Message, "$LS- ]")==Message) return;
 if (strstr(Message, "$LS= ]")==Message) return;
 if (strstr(Message, "FLSTB]")==Message) return;
 if (strstr(Message, "FLSTE]")==Message) return;

 if (strstr(Message, "$LS# ]")==Message) {

   sprintf(s,"A user file list download fails: %s",(char*)(Message+9));
   kol->insert(NewStr(s));
   s[0]='\0';

   } else {

   while (strlen(s)>75) {
     char s1[81], s2[MAXMSG];
     strncpy(s1, s, 75); s1[75]='\0';
     kol->insert(NewStr(s1));
     strcpy2(s2, (char*)(s+75));
     strcpy2(s, s2);
   }

 }
 
 if (strlen(s)>0) kol->insert(NewStr(s));
 LB->setRange(kol->getCount());
 LB->focusItem(kol->getCount()-1);
}
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
//             class TSInfoDial : public TDialog
/*-----------------------------------------------------------------*/
TSInfoDial::TSInfoDial(TRect AR, char* AT, THUB* AMain,
                       TSrchItem* Item, char* gdlfile, double gdlsize)
           :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
 AS   = false;
 Main = AMain;
 helpCtx = 20;
 
 char   b[512];
 TView* V;

 sprintf(b,"Owner (nick): %s", Item->Nick);
 insert(new TStaticText(TRect(2,2,70,3), b));

 sprintf(b,"Slots status:  total: %d   free: %d", Item->Slot_Total, Item->Slot_Free);
 insert(new TStaticText(TRect(2,3,70,4), b));

 sprintf(b,"    Filename: %s", Item->File);
 insert(new TStaticText(TRect(2,4,70,5), b));

 insert(new TStaticText(TRect(2,5,79,6), "   Full path:"));
 insert(new TStaticText(TRect(2,6,79,7), Item->Path));

 sprintf(b,"   File size: %12.2lf bytes", (double)Item->Size);
 insert(new TStaticText(TRect(2,8,70,9), b));
 sprintf(b,"   File size: %12.2lf Kbytes", (double)(Item->Size/1024.0));
 insert(new TStaticText(TRect(2,9,70,10), b));
 sprintf(b,"   File size: %12.2lf Mbytes", (double)(Item->Size/(1024.0*1024.0)));
 insert(new TStaticText(TRect(2,10,70,11), b));

 memset(b, '-', 50); b[50]='\0';
 insert(new TStaticText(TRect(1,11,54,12), b));

 if (gdlfile[0]!='\0') {
   insert(new TButton(TRect(2,12,22,14),"~A~dd as source to",  cmYes, bfNormal));
   insert(new TButton(TRect(2,14,22,16),"Add as a~u~toSearch", cmAS,  bfNormal));
   insert(new TStaticText(TRect(23,12,78,13), gdlfile));
   sprintf(b,"GDL final size: %12.2lf bytes", gdlsize);
   insert(new TStaticText(TRect(23,13,78,14), b));
 }
 V = new TButton(TRect(55,8,66,10),"~D~ownload", cmOK, bfNormal);
 insert(V);
 insert(new TButton(TRect(55,10,78,12),"~Q~uery user files", cmNo,     bfNormal));
 insert(new TButton(TRect(67,8,78,10),"Clos~e~",             cmCancel, bfNormal));

 setCurrent(V, (TView::selectMode)0);
}
/*-----------------------------------------------------------------*/
void TSInfoDial::shutDown()
{
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TSInfoDial::handleEvent(TEvent& event)
{
 TDialog::handleEvent(event);

 if (event.what==evCommand) {
   if (event.message.command = cmAS) {
     AS = true;
     event.message.command = cmYes;
     TDialog::handleEvent(event);
   }
 }
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//              class TPChatDial : public TDialog
/*-----------------------------------------------------------------*/
TPChatDial::TPChatDial(TRect AR, char* AT, THUB* AMain)
           :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main = AMain;
  helpCtx = 20;
  
  kol = new TNSStringCollection(10, 10);

  LB = new TListBox(TRect(1,1,78,8), 1, NULL);
  insert(LB);

  Nick = new TInputLine(TRect(12,9,43,10), 30);
  insert(Nick);
  insert(new TLabel(TRect(1,9,11,10), "To (~n~ick):", Nick));

  Chat = new TInputLine(TRect(12,10,78,11), 100);
  insert(Chat);
  insert(new TLabel(TRect(1,10,11,11), "  M~e~ssage:", Chat));

//  Insert(new TButton(TRect(65,9,76,11),"Close",cmCancel,bfDefault));

  kol->insert(NewStr(" "));
  dkol.items     = kol;
  dkol.selection = 0;
  LB->setData(&dkol);
  setCurrent(LB, (TView::selectMode)0);
}
/*-----------------------------------------------------------------*/
void TPChatDial::shutDown()
{
 destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TPChatDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF3:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
                  break;
     case kbEnter:
                  if (current!=Chat) {
                    event.what            = evCommand;
                    event.message.command = cmCancel;
                  }
                  if (current==Chat) {
                    clearEvent(event);
                    AddYourMessage();
                    return;
                  }
                  break;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TPChatDial::AddMessage(char* Message)
{
 if (strlen2(Message)<8) return;

 while (kol->getCount() > 100) {
   kol->atRemove(0);
   LB->setRange(kol->getCount());
   LB->focusItem(kol->getCount()-1);
 }

 char  s[MAXMSG];
 char* p;
 
 p = Message;
 strcpy2(s, NextItem(p));
 if (strcmp2(opt.Nick,s)==0) return;

 printf("%c",0x7);
 
 strcpy2(s, NextItem(p));

 while (strlen(s)>75) {
   char s1[81], s2[MAXMSG];
   strncpy(s1, s, 75); s1[75]='\0';
   kol->insert(NewStr(s1));
   strcpy2(s2, (char*)(s+75));
   strcpy2(s, s2);
 }
 if (strlen2(s)>0) kol->insert(NewStr(s));
 kol->insert(NewStr("-------------------------------------------------------------------------"));
 LB->setRange(kol->getCount());
 LB->focusItem(kol->getCount()-1);
}
/*-----------------------------------------------------------------*/
void TPChatDial::AddYourMessage()
{
 char m[101];
 char n[31];
 char b[150];
 
 Chat->getData(m);
 if (m[0]=='\0') return;
 Nick->getData(n);
 if (n[0]=='\0') return;

 sprintf(b,"/PRIV *%s*%s\n", n, m);

 Main->SendMsg(b);

 memset(n, 0x0, sizeof(n));
 Chat->setData(n);
}
/*-----------------------------------------------------------------*/
void TPChatDial::SetNick(char* ANick)
{
 if (strlen(ANick)==0) return;
 char b[1];
 b[0]='\0';
 Chat->setData(b);
 Nick->setData(ANick);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//           class TCommDial : public TDialog
/*-----------------------------------------------------------------*/
TCommDial::TCommDial(TRect AR, char* AT, THUB* AMain)
          :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main    = AMain;
  helpCtx = 20;
  
  TInputLine* IL;
  IL = new TInputLine(TRect(11, 2, 75,3 ), 60);
  insert(IL);

  THistory* H;
  H = new THistory(TRect(76,2,79,3), IL, 1);
  insert(H);
  historyAdd(1,  "/FOLLOWFORCE");
  historyAdd(1,  "/UNFOLLOWFORCE");
  historyAdd(1,  "/XFER");
  historyAdd(1,  "/SLOT ");
  historyAdd(1,  "/PASSIVE");
  historyAdd(1,  "/ACTIVE");
  historyAdd(1,  "/ULIST");
  historyAdd(1,  "/AWAY");
  historyAdd(1,  "/HERE");
  historyAdd(1,  "/DLON");
  historyAdd(1,  "/DLOFF");
  historyAdd(1,  "/PASSWD ");
  insert(new TLabel(TRect(1,2,10,3), "Command:", IL));

  C[0]='\0';
  setData(C);
}
/*-----------------------------------------------------------------*/
void TCommDial::shutDown()
{
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TCommDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbEnter:
                  getData(C);
                  event.what            = evCommand;
                  event.message.command = cmOK;
                  break;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
//                class TAdvSrchDial : public TDialog
/*-----------------------------------------------------------------*/
TAdvSrchDial::TAdvSrchDial(TRect AR, char* AT, THUB* AMain)
             :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  TView* V;

  Main = AMain;
  helpCtx = 30;

  insert(new TStaticText(TRect(5,2,25,3), "Search words:"));
  
  IL[0] = new TInputLine(TRect(4,3,25,4), 21);
  insert(IL[0]);
  insert(new TLabel(TRect(2,3,3,4), "1.", IL[0]));
  
  IL[1] = new TInputLine(TRect(4,4,25,5), 21);
  insert(IL[1]);
  insert(new TLabel(TRect(2,4,3,5), "2.", IL[1]));

  IL[2] = new TInputLine(TRect(4,5,25,6), 21);
  insert(IL[2]);
  insert(new TLabel(TRect(2,5,3,6), "3.", IL[2]));

  IL[3] = new TInputLine(TRect(4,6,25,7), 21);
  insert(IL[3]);
  insert(new TLabel(TRect(2,6,3,7), "4.", IL[3]));

  
  insert(new TRadioButtons(TRect(2, 8, 26, 10),
             new TSItem("Words operator OR",
             new TSItem("Words operator AND",
             NULL))));

  V = new TRadioButtons(TRect(28, 3, 45, 11),
             new TSItem("Any",
             new TSItem("Audio",
             new TSItem("Compressed",
             new TSItem("Document",
             new TSItem("EXEcutable",
             new TSItem("Picture",
             new TSItem("Videos",
             new TSItem("Folder",
             NULL)))))))));
  insert(V);
  insert(new TLabel(TRect(29, 2, 39, 3), "~F~iletype:", V));

  IL[4] = new TInputLine(TRect(50, 3, 72, 4), 21);
  IL[4]->SetValidator(new TNumberValidator());
  insert(IL[4]);
  insert(new TLabel(TRect(51, 2, 61, 3), "File si~z~e:", IL[4]));

  V = new TRadioButtons(TRect(50, 6, 70, 9),
          new TSItem("Any",
          new TSItem("at last size",
          new TSItem("at most size",
          NULL))));
  insert(V);
  insert(new TLabel(TRect(51, 5, 70, 6), "Size ~t~ype:", V));

  insert(new TCheckBoxes(TRect(50, 10, 75, 11),
             new TSItem("Only with free slot", NULL)));
             
  setCurrent(IL[0], (TView::selectMode)0);
}
/*-----------------------------------------------------------------*/
void TAdvSrchDial::shutDown()
{
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TAdvSrchDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbEnter:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//              class TExtraDial : public TDialog
/*-----------------------------------------------------------------*/
TExtraDial::TExtraDial(TRect AR, char* AT, THUB* AMain)
           :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
  Main = AMain;
  helpCtx = 20;
  
  insert(new TRadioButtons(TRect(1,1,79,6),
             new TSItem("Show info about all users (conn.type, shared, etc.)",
             new TSItem("Set AWAY mode",
             new TSItem("Back to HERE mode",
             new TSItem("Enable link between dctc servers",
             new TSItem("Disable link between dctc servers",
             NULL)))))));

  C = 0;
  setData(&C);
}
/*-----------------------------------------------------------------*/
void TExtraDial::shutDown()
{
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TExtraDial::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbEnter:
                  getData(&C);
                  event.what            = evCommand;
                  event.message.command = cmOK;
                  break;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/

