/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * d_error.h: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __D_ERROR_H
#define __D_ERROR_H
/*-----------------------------------------------------------------*/
#define Uses_TStringCollection
#define Uses_TDialog
#define Uses_TListBox
#define Uses_TInputLine
#include <tv.h>

#include "tools.h"

/*-----------------------------------------------------------------*/
class THUB;
/*-----------------------------------------------------------------*/
class TErrorDial : public TDialog
{
 public:
                TErrorDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void AddMessage(char* Message);
           void handleEvent(TEvent& event);
 private:
    TStringCollection* kol;
             TListBox* LB;
          TListBoxRec  dkol;
                 THUB* Main;
};
/*-----------------------------------------------------------------*/
class TAutoDial : public TDialog
{
 public:
                TAutoDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void AddMessage(char *Message);
           void handleEvent(TEvent &event);
 private:
    TNSStringCollection* kol;
               TListBox* LB;
            TListBoxRec  dkol;
                   THUB* Main;
};
/*-----------------------------------------------------------------*/
class TOtherDial : public TDialog
{
 public:
                TOtherDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void AddMessage(char* Message, bool trunc = true);
           void handleEvent(TEvent& event);
 private:
    TNSStringCollection* kol;
               TListBox* LB;
            TListBoxRec  dkol;
                   THUB* Main;
};
/*-----------------------------------------------------------------*/
class TSInfoDial : public TDialog
{
 public:
                TSInfoDial(TRect AR, char* AT,
                           THUB* AMain, TSrchItem* Item,
                           char* gdlfile, double gdlsize);
           void shutDown();
           void handleEvent(TEvent& event);

           bool AS;
 private:
           THUB* Main;
};
/*-----------------------------------------------------------------*/
class TPChatDial : public TDialog
{
 public:
                TPChatDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void AddMessage(char *Message);
           void handleEvent(TEvent& event);
           void AddYourMessage();
           void SetNick(char* ANick);
 private:
    TNSStringCollection* kol;
               TListBox* LB;
            TListBoxRec  dkol;

             TInputLine* Nick;
             TInputLine* Chat;
                   THUB* Main;
};
/*-----------------------------------------------------------------*/
class TCommDial : public TDialog
{
 public:
                TCommDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void handleEvent(TEvent& event);

           char C[61];
 private:
           THUB* Main;
};
/*-----------------------------------------------------------------*/
class TAdvSrchDial : public TDialog
{
 public:
                TAdvSrchDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void handleEvent(TEvent& event);

           struct {
             char    s[4][21];
             ushort  Operator;
             ushort  Type;
             char    Size[21];
             ushort  SizeType;
             ushort  FreeSlot;
             } /*__attribute__ ((packed))*/ sdata;
         TInputLine* IL[5]; // 0-3 pattern 4-filesize
 private:
               THUB* Main;
};
/*-----------------------------------------------------------------*/
class TExtraDial : public TDialog
{
 public:
                TExtraDial(TRect AR, char* AT, THUB* AMain);
           void shutDown();
           void handleEvent(TEvent& event);

           ushort C;
 private:
             THUB* Main;
};
/*-----------------------------------------------------------------*/
#endif
