/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * gdl.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GDL_H
#include "gdl.h"
#endif

/*-----------------------------------------------------------------*/
#include <string.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>

#define Uses_MsgBox
#define Uses_TKeys
#define Uses_TEvent
#define Uses_TDeskTop
#define Uses_TLabel
#define Uses_StaticText
#define Uses_TButton
#include <tv.h>

#include "main.h"
#include "liczby.h"
#include "options.h"
#include "tools.h"
#include "search.h"
#include "const.h"
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//                   class TGLD : public TObject
/*-----------------------------------------------------------------*/
TGDL::TGDL(TDialog* AMain):TObject()
{
 Main = AMain;
 kol  = NULL;
}
/*-----------------------------------------------------------------*/
void TGDL::shutDown()
{
 if (kol!=NULL) destroy(kol);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/
TObjCollection* TGDL::Build()
{
           DIR* dir;
 struct dirent* obj;
          char  gdlpath[215];
          char  gdlpath1[512];

 // if (kol!=NULL) Destroy(kol);
 kol = new TObjCollection(10,10);
 
 if( downloadDir[0] != 0 ) {
   sprintf(gdlpath1, "%s/GDL", downloadDir);
   } else {
   strcpy2(gdlpath1, "./GDL");
 }
 dir=opendir(gdlpath1);
 if ( dir!=NULL ) {
   while((obj=readdir(dir))!=NULL){
     if (strlen(obj->d_name)>2 ) {
       TGDLItem *I = new TGDLItem();
       I->FileName = NewStr(obj->d_name);
       sprintf(gdlpath,"%s/%s/.cmd", gdlpath1, obj->d_name);
       GetDetails(I, gdlpath);
       kol->insert(I);
     }
   }
 }
 closedir(dir);

 return kol;
}
/*-----------------------------------------------------------------*/
void TGDL::TestActive(char* Msg)
{
     char* p;
     char  b[MAXMSG];
      int  poz;
 TGDLItem* Item;
    ulong  tmp_id;
   ushort  n;

 p   = (char*)(Msg+9);
 poz = 0;
 while ((*p!='\0')&&(*p!='|')) {
   b[poz++] = *p;
   p++;
 }
 b[poz]='\0';
 tmp_id = Str2Long(b);

 for (n=0; n<kol->getCount(); n++) {
   Item = (TGDLItem*)kol->at(n);
   if (Item->ID==tmp_id) {
     Item->Attach = true;
     return;
   }
 }

}
/*-----------------------------------------------------------------*/
ushort TGDL::ShowDialog(ushort AItem)
{
 TGDLItem* I;
   ushort  ret;

 I = (TGDLItem *)kol->at(AItem);

 TGDLDial *D = new TGDLDial(TRect(0,1,80,18), I->FileName, Main, I);
 if (DCApp->validView(D)) {
   ret = DCApp->deskTop->execView(D);
   } else {
   ret = cmCancel;
 }
 DCApp->destroy(D);
 return ret;
}
/*-----------------------------------------------------------------*/
void TGDL::GetDetails(TGDLItem* Item, char* gdlpath)
{
 FILE *f;
 char  a[512],b[512];
 
 f = fopen(gdlpath, "r");
 if (f==NULL) {
   messageBox("Can't read .cmd file.", mfError|mfOKButton);
   return;
 }
 
 fgets(a,sizeof(a),f);
 if (a[0]!='G') {
   messageBox("Bad .cmd file format.", mfError|mfOKButton);
   fclose(f);
   return;
 }
 fclose(f);
 
 char* p;
 int   poz;
 
 p = (char*)(a+2);

 strcpy(b, NextItem(p));
 Item->ID = Str2Long(b);

 //--- FileName
 strcpy(b, NextItem(p));

 //--- Size
 strcpy(b, NextItem(p));
 Item->Size = Str2Long(b);
}
/*-----------------------------------------------------------------*/
void TGDL::Download(TSrchItem* I)
{
   ushort  n;
 TGDLItem* GDLItem;
     char  b[512];
     THUB* H;

 H = (THUB*)Main;
 
 for (n=0; n<kol->getCount();n++) {
   GDLItem = (TGDLItem*)kol->at(n);
   if (strcasecmp(I->File, GDLItem->FileName)==0) {
     // ADD NEW SOURCE ONLY;
     if (I->Size != GDLItem->Size) {
       messageBox("GDL final size and\ncremote file size\ncare different !", mfError|mfOKButton);
       return;
     }
     if (!GDLItem->Attach) {
       sprintf(b,"/GDLATTACH %s\n", GDLItem->FileName);
       H->SendMsg(b);
     }
     sprintf(b, "/GDLADD %ld|%s|%s|%ld\n",
             GDLItem->ID, I->Nick, I->Path, I->Size);
     H->SendMsg(b);
     usleep(100000);
     return;
   }
 }
 //check for first free ID
 long ID = 0L;
 for (n=0; n<kol->getCount();n++) {
   GDLItem = (TGDLItem*)kol->at(n);
   if ( GDLItem->ID>ID ) {
     ID = GDLItem->ID;
   }
 }
 ID++;

 sprintf(b,"/GDLNEW %ld|%ld|%s\n", ID, I->Size, I->File);
 H->SendMsg(b);
 usleep(100000);
 sprintf(b, "/GDLADD %ld|%s|%s|%ld\n", ID, I->Nick, I->Path, I->Size);
 H->SendMsg(b);
 usleep(100000);
}
/*-----------------------------------------------------------------*/
void TGDL::DownloadSrc(TSrchItem* I, TGDLItem* GI)
{
   ushort  n;
 TGDLItem* GDLItem;
     char  b[512];
     THUB* H;

 H = (THUB*)Main;
 
 GDLItem = GI;
 if (I->Size != GDLItem->Size) {
   messageBox("GDL final size and\ncremote file size\ncare different !", mfError|mfOKButton);
   return;
 }

 if (!GDLItem->Attach) {
   sprintf(b,"/GDLATTACH %s\n", GDLItem->FileName);
   H->SendMsg(b);
 }
 sprintf(b, "/GDLADD %ld|%s|%s|%ld\n",
            GDLItem->ID, I->Nick, I->Path, I->Size);
 H->SendMsg(b);
 usleep(100000);
 return;
}
/*-----------------------------------------------------------------*/
void TGDL::AutoSearch(TSrchItem* I, TGDLItem* GI)
{
   ushort  n;
 TGDLItem* GDLItem;
     char  b[512];
     THUB* H;

 H = (THUB*)Main;
 
 GDLItem = GI;
 if (I->Size != GDLItem->Size) {
   messageBox("GDL final size and\ncremote file size\nare different !", mfError|mfOKButton);
   return;
 }

 if (!GDLItem->Attach) {
   sprintf(b,"/GDLATTACH %s\n", GDLItem->FileName);
   H->SendMsg(b);
 }
 sprintf(b, "/GDLAS+ %ld|0|%s\n",
            GDLItem->ID, I->File);
 H->SendMsg(b);
 usleep(100000);
 return;
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
//              class TGDLItem : public TObject
/*-----------------------------------------------------------------*/
TGDLItem::TGDLItem():TObject()
{
 Attach   = false;
 FileName = NULL;
 ID       = 0L;
 Size     = 0L;
}
/*-----------------------------------------------------------------*/
void TGDLItem::shutDown()
{
 DelStr(FileName);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
//           class TGDLSrcItem : public TObject
/*-----------------------------------------------------------------*/
TGDLSrcItem::TGDLSrcItem():TObject()
{
 Nick = NULL;
 Path = NULL;
}
/*-----------------------------------------------------------------*/
void TGDLSrcItem::shutDown()
{
 DelStr(Nick);
 DelStr(Path);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//             class TGDLDial : public TDialog
/*-----------------------------------------------------------------*/
TGDLDial::TGDLDial(TRect AR, char* AT, TDialog* AMain,TGDLItem* AItem)
         :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
 Main = AMain;
 Item = AItem;

   char b[81];
 double mb1,mb2;

 mb1 = (double)(Item->Size/(1024.0*1024.0));
 sprintf(b,"ID:%ld  Final size: %ld bytes (%.2lf kB) (%.2lf MB)",
         Item->ID,
         Item->Size,
         (double)(Item->Size/1024.0),
         mb1);
 insert(new TStaticText(TRect(2,1,76,2), b));

 GetReady();
 mb2 = (double)(ready/(1024.0*1024.0));
 sprintf(b,"About %.2lf MB done. (%.2lf%% ready).", mb2, (double)((mb2/mb1)*100.0) );
 insert(new TStaticText(TRect(2,2,76,3), b));

 //insert(new TStaticChar(TRect(1,3,78,4),''));

 LB = new TGDLSrcListBox(TRect(1,5,78,11), 1, NULL);
 insert(LB);
 insert(new TLabel(TRect(2,4,40,5), "~S~ources", LB));

 kol            = new TObjCollection(10,10);
 dkol.items     = kol;
 dkol.selection = 0;
 ReadSources();
 LB->setData(&dkol);

 insert(new TButton(TRect( 2,12,19,14), "~D~elete source",   cmDelSrc,   bfNormal));
 insert(new TButton(TRect(37,12,56,14), "C~a~ncel download", cmKill,     bfNormal));
 insert(new TButton(TRect(57,12,69,14), "~A~ctivate",        cmActivate, bfNormal));
 insert(new TButton(TRect(70,12,78,14), "~H~old",            cmHold,     bfNormal));
 insert(new TButton(TRect(57,14,78,16), "Clos~e~",           cmCancel,   bfNormal));

 /*
 TCommandSet s = curCommandSet;
 if (Item->Attach) {
   s += cmActivate;
   s -= cmHold;
   } else {
   s += cmActivate;
   s -= cmHold;
 }
 setCommands(s);
 */
}
/*-----------------------------------------------------------------*/
void TGDLDial::shutDown()
{
 if (kol!=NULL) destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TGDLDial::idle()
{
 DCApp->idle();
}
/*-----------------------------------------------------------------*/
void TGDLDial::handleEvent(TEvent& event)
{
/*
 if (Event.What==evKeyDown) {
   switch (Event.KeyDown.KeyCode) {
     case kbEnter:
                  Event.What    = evCommand;
                  Event.Command = cmCancel;
   }
 }
 */
 TDialog::handleEvent(event);
 if (event.what==evCommand) {
   switch (event.message.command) {
     case cmActivate:  Activate(); break;
     case cmHold:      Hold();     break;
     case cmKill:      Kill();     break;
     case cmDelSrc:    DelSrc();   break;
     default:                      return;
   }
 }
}
/*-----------------------------------------------------------------*/
void TGDLDial::Activate()
{
 char b[256];
 sprintf(b,"/GDLATTACH %s\n", Item->FileName);

 THUB* H = (THUB*)Main;
 
 H->SendMsg(b);
 usleep(100000);

 TEvent event;
 event.what            = evCommand;
 event.message.command = cmOK;
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TGDLDial::Hold()
{
 char  b[256];
 THUB* H =(THUB*)Main;
 
 if (!Item->Attach) {
  sprintf(b,"/GDLATTACH %s\n", Item->FileName);
  H->SendMsg(b);
 }

 sprintf(b,"/GDLDETACH %ld\n", Item->ID);
 H->SendMsg(b);
 usleep(100000);

 TEvent event;
 event.what            = evCommand;
 event.message.command = cmOK;
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TGDLDial::Kill()
{
 char  b[256];
 THUB* H = (THUB*)Main;

 if (messageBox("Are you sure ?\nAll temp files will be deleteted !", mfConfirmation|mfYesButton|mfNoButton)!=cmYes)
   return;

 if (!Item->Attach) {
  sprintf(b,"/GDLATTACH %s\n", Item->FileName);
  H->SendMsg(b);
  usleep(100000);
 }
 sprintf(b,"/GDLEND %ld\n", Item->ID);

 H->SendMsg(b);
 usleep(100000);

 TEvent event;
 event.what            = evCommand;
 event.message.command = cmOK;
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TGDLDial::DelSrc()
{
 LB->getData(&dkol);
 TGDLSrcItem *I = (TGDLSrcItem*)kol->at(dkol.selection);

 char  b[256];
 THUB* H = (THUB*)Main;
 
 if (!Item->Attach) {
  sprintf(b,"/GDLATTACH %s\n", Item->FileName);
  H->SendMsg(b);
  usleep(100000);
 }
 sprintf(b,"/GDLDEL %ld|%s|%s\n", Item->ID, I->Nick, I->Path);

 H->SendMsg(b);
 usleep(100000);

 TEvent event;
 event.what            = evCommand;
 event.message.command = cmOK;
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/
void TGDLDial::ReadSources()
{
 FILE *f;
 char  a[512],b[512], gdlpath[215];

 sprintf(gdlpath,"%s/GDL/%s/.cmd",downloadDir,Item->FileName);
 f = fopen(gdlpath,"r");
 if (f==NULL) {
   messageBox("Can't read .cmd file.", mfError|mfOKButton);
   return;
 }
 
 while (fgets(a,sizeof(a),f)!=NULL) {
   if (a[0]=='S') {
     char* p;
     int   poz;

     TGDLSrcItem *I = new TGDLSrcItem();
     p  = (char*)(a+2);

     strcpy(b, NextItem(p));
     I->Nick = NewStr(b);

     strcpy(b, NextItem(p));
     I->Path = NewStr(b);

     kol->insert(I);
   }
 }
 fclose(f);

}
/*-----------------------------------------------------------------*/
void TGDLDial::GetReady()
{
 ready = 0L;

           DIR* dir;
 struct dirent* obj;
          char  gdlpath[215],gdlpath1[215];
           int  err;
   struct stat  st;

 sprintf(gdlpath1,"%s/GDL/%s",downloadDir,Item->FileName);

 dir=opendir(gdlpath1);
 if ( dir!=NULL ) {
   while((obj=readdir(dir))!=NULL){
     if (strlen(obj->d_name)>5 ) {
       sprintf(gdlpath,"%s/%s", gdlpath1, obj->d_name);
       err = stat(gdlpath, &st);
       if (err!=-1) ready += st.st_size;
     }
   }
 }
 closedir(dir);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//           class TGDLSrcListBox : public TListBox
/*-----------------------------------------------------------------*/
TGDLSrcListBox::TGDLSrcListBox(TRect AR, ushort AC, TScrollBar* SB)
               :TListBox(AR,AC,SB)
{
}
/*-----------------------------------------------------------------*/
void TGDLSrcListBox::shutDown()
{
 TListBox::shutDown();
}
/*-----------------------------------------------------------------*/
void TGDLSrcListBox::getText(char* dest, ccIndex item, short maxLen)
{
 TGDLSrcItem* I;
        char  s[256];

 I = (TGDLSrcItem*)items->at(item);

 sprintf(s,"%-20s%c%s", I->Nick, columnSeparator, I->Path);
 s[(maxLen<256?maxLen:256)]='\0';
 strcpy(dest, s);
}
/*-----------------------------------------------------------------*/

