/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * gdl.h: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GDL_H
#define __GDL_H
/*-----------------------------------------------------------------*/

#define Uses_TCommandSet
#define Uses_TDialog
#define Uses_TListBox
#include <tv.h>

#include "tools.h"
/*-----------------------------------------------------------------*/
class TGDLItem : public TObject
{
 public:
                TGDLItem();
           void shutDown();

            bool  Attach;
            char* FileName;
            long  ID;
            long  Size;
};
/*-----------------------------------------------------------------*/
class TGDLSrcItem : public TObject
{
 public:
                TGDLSrcItem();
           void shutDown();

            char* Nick;
            char* Path;
};
/*-----------------------------------------------------------------*/

class TGDL : public TObject
{
 public:
                TGDL(TDialog* AMain);
           void shutDown();

           void  TestActive(char* Msg);
           void  Download(TSrchItem* I);
           void  DownloadSrc(TSrchItem* I, TGDLItem* GI);
           void  AutoSearch(TSrchItem* I, TGDLItem* GI);
         ushort  ShowDialog(ushort AItem);
 TObjCollection* Build();

 private:
        TDialog* Main;
 TObjCollection* kol;

          void  GetDetails(TGDLItem* Item, char* gdlpath);
};
/*-----------------------------------------------------------------*/
class TGDLSrcListBox : public TListBox
{
 public:
                        TGDLSrcListBox(TRect AR, ushort AC, TScrollBar* SB);
                   void shutDown();
                   void getText(char* dest, ccIndex item, short maxLen);
};
/*-----------------------------------------------------------------*/
class TGDLDial : public TDialog
{
 public:
                TGDLDial(TRect AR, char* AT, TDialog* AMain, TGDLItem* AItem);
           void shutDown();
           void idle();
           void handleEvent(TEvent& event);
 private:
    TObjCollection* kol;
    TGDLSrcListBox* LB;
       TListBoxRec  dkol;
           TDialog* Main;
          TGDLItem* Item;
     unsigned long  ready;

           void ReadSources();
           void GetReady();
           void Activate();
           void Hold();
           void Kill();
           void DelSrc();
};
/*-----------------------------------------------------------------*/
#endif
