/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * hub.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "hub.h"
/*-----------------------------------------------------------------*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#define Uses_THistory
#define Uses_TLabel
#define Uses_MsgBox
#define Uses_TButton
#include <tv.h>

#include "liczby.h"
#include "inifile.h"
#include "options.h"
#include "search.h"
#include "const.h"
#include "main.h"
#include "tools.h"
/*-----------------------------------------------------------------*/
char LastServ[128];
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
void Servers()
{
 ushort ret;
   char b[81];
   char a[81];
 
 THubsDial* D = new THubsDial(TRect(0,0,80,20), "Hubs list");
 D->options |= ofCentered;
 D->flags   |= wfGrow|wfZoom;
 
 if (DCApp->validView(D)) {
   ret=DCApp->deskTop->execView(D);
   if (ret == cmOK) {
     strcpy2(b, D->Go);
     strcpy2(a, D->Addr);
   }
   } else {
   ret = cmCancel;
 }
 DCApp->destroy(D);

 if (ret==cmOK) InsertHUB(b, a, true);
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
//             class THubsDial : public TDialog
/*-----------------------------------------------------------------*/
THubsDial::THubsDial(TRect AR, char* ATitle)
          :TDialog(AR, ATitle),TWindowInit(TDialog::initFrame)
{
 helpCtx=5;

    TRect    R;
 THistory*   H;
 TScrollBar* SB;
    TView*   V;

 SB = new TScrollBar(TRect(78,2,79,14));
 insert(SB);
 LB = new THubListBox(TRect(1,2,78,14), 1, SB);
 LB->growMode = gfGrowHiX|gfGrowHiY;
 
 insert(LB);
 insert(new TLabel(TRect(1,1,78,2), "Usrs ~H~ub name                  Hub description", LB));

 insert(Host = new TInputLine(TRect(14,15,36,16), 120));
 Host->growMode = gfGrowLoY|gfGrowHiY;
 insert(V = new TLabel(TRect(2,15,13,16), "Fo~r~ce Host:", Host));
 V->growMode = gfGrowLoY|gfGrowHiY;
 insert(H = new THistory(TRect(36,15,38,16), Host, 10));
 H->growMode = gfGrowLoY|gfGrowHiY;

 TINIfile* ini;
     char  buf[256];
 
 ini = new TINIfile(true);
 int n=1;
 while ( (ini->Read(cfgFile,"Hosts", n++, buf,"")) && (n<11) ) {
   if (buf[0]!='\0')
     historyAdd(10, buf);
 }
 delete ini;

 insert(Port = new TInputLine(TRect(51,15,57,16), 5));
 Port->growMode = gfGrowLoY|gfGrowHiY;
 insert(V = new TLabel(TRect(42,15,50,16), "on ~p~ort:", Port));
 V->growMode = gfGrowLoY|gfGrowHiY;
 
 insert(V = new TButton(TRect(2,17,13,19), "Co~n~nect", cmConnect, bfDefault));
 V->growMode = gfGrowLoY|gfGrowHiY;
 insert(V = new TButton(TRect(14,17,25,19), "Re~f~resh", cmRead, bfNormal));
 V->growMode = gfGrowLoY|gfGrowHiY;
 // insert(V = new TButton(TRect(30,17,60,19), "~A~ttach to working DCTC", cmAttache, bfNormal));
 // V->growMode = gfGrowAll;
 insert(V = new TButton(TRect(65,17,76,19), "Clos~e~", cmCancel, bfNormal));
 V->growMode = gfGrowAll;
 

 Go[0]='\0';
 Host->setData(Go);
 Port->setData(Go);
 
 kol = NULL;
 Read();

 setCurrent(LB, (TView::selectMode)0);
}
/*-----------------------------------------------------------------*/
void THubsDial::shutDown()
{
 if (kol!=NULL) destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void THubsDial::sizeLimits(TPoint& min, TPoint& max)
{
 min.x = 80;
 min.y = 20;
 if (owner!=0) {
   max = owner->size;
   } else {
   max.x = max.y = INT_MAX;
 }
}
/*-----------------------------------------------------------------*/
void THubsDial::handleEvent(TEvent& event)
{
 TDialog::handleEvent(event);
 if (event.what==evCommand) {
   switch (event.message.command) {
//     case cmAttache: attachOnly = true;
     case cmConnect: bool ok;
                     ok = Connect();
                     clearEvent(event);
                     event.what    = evCommand;
                     if (ok==true) {
                       event.message.command = cmOK;
                       } else {
                       event.message.command = cmCancel;
                     }
                     TDialog::handleEvent(event);
                     return;
     case cmRead:    Read1();                break;
     default:                               return;
   }
   clearEvent(event);
 }
}
/*-----------------------------------------------------------------*/
void THubsDial::Read1()
{
 char b[512];
 
 sprintf(b,"%s/hublist", opt.Dctc);
 if (access(b,X_OK)!=0) {
   messageBox("\003Can't found\n\003hublist program !", mfError|mfOKButton);
   return;
 }

 WaitON(False, "Connecting...");
 sprintf(b,"%s/hublist 1>%s/.ldcc/hubs.txt 2>%s/.ldcc/hubs.txt.err",
            opt.Dctc, getenv("HOME"), getenv("HOME"));
 system(b);
 usleep(1000);
 WaitOFF();
 Read();
}
/*-----------------------------------------------------------------*/
bool THubsDial::Connect()
{
     char  H[130], P[6];
     char  b[2048];
 THubItem* Item;
 
 Host->getData(H);
 Port->getData(P);

 sprintf(b,"%s/dctc", opt.Dctc);
 if (access(b,X_OK)!=0) {
   messageBox("\003Can't found\n\003dctc program !", mfError|mfOKButton);
   return false;
 }

 if (H[0]!='\0') {
   if (P[0]!='\0') {
     strcat(H,":");
     strcat(H,P);
   }
   sprintf(b,"%s/dctc -g %s -n '%s' -i '%s' -d %s -o %s -a %s -p %s",
           opt.Dctc, H, opt.Nick, opt.Info, opt.Slots, opt.Offset, opt.HostIP, opt.HostPort);
   strcpy2(Addr, H);
   strcpy2(LastServ, H);
   } else {
   if (kol==NULL) return false;
   if (kol->getCount()==0) return false;

   LB->getData(&dkol);
   Item = (THubItem*)kol->at(dkol.selection);
   sprintf(b,"%s/dctc -g %s -n '%s' -i '%s' -d %s -o %s -a %s -p %s",
           opt.Dctc, Item->IP, opt.Nick, opt.Info, opt.Slots, opt.Offset, opt.HostIP, opt.HostPort);
   strcpy2(Addr, Item->IP);
   strcpy2(LastServ, Item->Name);
 }
 if (opt.ConnType[0]!='\0') {
   strcat(b," -c '"); strcat(b, opt.ConnType); strcat(b,"'");
 }
 if (opt.Firewall==1) strcat(b," -f");
 if (opt.MD5==1) strcat(b," -5");
 if (opt.DDL==1) strcat(b," -b /DDL");
 if (opt.VSharedDir[0]!='\0') {
   strcat(b," -D '");
   strcat(b, opt.VSharedDir);
   strcat(b,"'");
 }

 TINIfile* ini;
     char  buf1[256];
     
 ini = new TINIfile(true);
 int i=1L;
 while ( (ini->Read(cfgFile,"Shared", i++, buf1, "")) && (i<21) ) {
   if (buf1[0]!='\0') {
     strcat(b, " -s '");
     strcat(b, buf1);
     strcat(b,"'");
   }
 }
 destroy(ini);
 
 strcat2(b, " --precmd='/LPATH ");
 strcat2(b, downloadDir);
 strcat2(b,"'");

 strcat(b, " -l -t &");

 //---  run dctc !
 DEB2("DCTC START>", b);
 system(b);
 usleep(1000000);

 strcpy2(Go, Addr);
 return true;
}
/*-----------------------------------------------------------------*/
void THubsDial::Read()
{
     FILE* f;
     char  buf[MAXMSG];
 THubItem* Item;

 sprintf(buf,"%s/.ldcc/hubs.txt", getenv("HOME"));
 f = fopen(buf, "r");
 if (f==NULL) return;

 kol = new THubCollection(100,10);
 kol->duplicates = true;
 dkol.items      = kol;
 dkol.selection  = 0;

 char* buf1 = NewStr(MAXMSG);
 
 while (fgets(buf, sizeof(buf),f)!=NULL) {

   if (strlen(buf)>10) {
     Item = new THubItem();
     
     char* p = buf;  // linia z hubem

     //--- Nazwa huba
     strcpy2(buf1, NextItem(p));
     if (strlen(buf1) > 25)  buf1[25]='\0'; // ogranicz do 25 znakow
     Item->Name = NewStr(buf1);
     
     //--- Adres lub IP huba
     strcpy2(buf1, NextItem(p));
     Item->IP = NewStr(buf1);
     
     //--- Opis huba
     strcpy2(buf1, NextItem(p));
     if (strlen(buf1) > 80)  buf1[80]='\0'; // ogranicz do 80 znakow
     Item->Desc = NewStr(buf1);

     //--- Ilosc uzytkownikow na hubie
     strcpy2(buf1, NextItem(p));
     Item->Users = Str2Ushort(buf1);

     //--- OK, dodaj do listy
     kol->insert1(Item);
   }
 }
 DelStr(buf1);
 fclose(f);

 if ((kol->getCount()!=0) && (LastServ[0]!='\0')) {
   for (ushort n=0; n<kol->getCount(); n++) {
     Item = (THubItem*)kol->at(n);
     if (Item->Name!=NULL) {
       if (strstr(LastServ, Item->Name)==LastServ) {
         dkol.selection = n;
         break;
       }
     }
   }
 }

 LB->setData(&dkol);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//             class THubItem : public TObject
/*-----------------------------------------------------------------*/
THubItem::THubItem():TObject()
{
 Name = NULL;
 IP   = NULL;
 Desc = NULL;
 Users= 0;
}
/*-----------------------------------------------------------------*/
void THubItem::shutDown()
{
 DelStr(Name);
 DelStr(IP);
 DelStr(Desc);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//         class THubCollection : public TCollection
/*-----------------------------------------------------------------*/
THubCollection::THubCollection(ccIndex aLimit, ccIndex aDeleta)
               :TSortedCollection(aLimit, aDeleta)
{
}
/*-----------------------------------------------------------------*/
void THubCollection::shutDown()
{
 TSortedCollection::shutDown();
}
/*-----------------------------------------------------------------*/
void THubCollection::insert1(void* Obj)
{
 if (Obj==NULL) return;

 // Checking the same HUB names in collection
 THubItem* H_new = (THubItem*)Obj;

 for (ushort n=0; n<getCount(); n++) {
   THubItem* H_old = (THubItem*)at(n);
   if (strcmp2(H_old->Name, H_new->Name)==0) {
     destroy((THubItem*)Obj);
     return;
   }
 }

 // OK, this is new name - add to collection
 insert(Obj);
}
/*-----------------------------------------------------------------*/
int THubCollection::compare(void* key1, void* key2)
{
 THubItem* H1 = (THubItem*)key1;
 THubItem* H2 = (THubItem*)key2;

 if (H1->Users < H2->Users ) return +1;
 if (H1->Users > H2->Users ) return -1;
 return 0;
}
/*-----------------------------------------------------------------*/
void* THubCollection::readItem( ipstream& )
{
 return NULL;
}
/*-----------------------------------------------------------------*/
void THubCollection::writeItem( void *, opstream& )
{
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//              class THubListBox : public TListBox
/*-----------------------------------------------------------------*/
THubListBox::THubListBox(const TRect& bounds, ushort aNumCols,
                         TScrollBar* aScrollBar)
            :TListBox(bounds, aNumCols, aScrollBar)
{
}
/*-----------------------------------------------------------------*/
void THubListBox::shutDown()
{
 TListBox::shutDown();
}
/*-----------------------------------------------------------------*/
void THubListBox::getText(char* dest, ccIndex item, short maxLen)
{
 THubItem* I;
 char      s[128];

 if (items!=0) {
   I = (THubItem*)items->at(item);
   sprintf(s, "%4d%c%-25s%c%s", I->Users, columnSeparator,
                                I->Name,  columnSeparator,
                                I->Desc);
   } else {
   s[0]='\0';
 }
 s[(maxLen<128?maxLen:128)]='\0';
 strcpy(dest, s);
}
/*-----------------------------------------------------------------*/

