/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * hub.h: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __HUB_H
#define __HUB_H
/*-----------------------------------------------------------------*/

#define Uses_TSortedCollection
#define Uses_TListBox
#define Uses_TInputLine
#define Uses_TDeskTop
#define Uses_TDialog
#include <tv.h>

/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
class THubItem : public TObject
{
 public:
                THubItem();
           void shutDown();

           char* Name;
           char* IP;
           char* Desc;
         ushort  Users;
};
/*-----------------------------------------------------------------*/
class THubCollection : public TSortedCollection
{
 public:
                THubCollection(ccIndex aLimit, ccIndex aDeleta);
           void shutDown();
            int compare(void* key1, void* key2);
           void insert1(void* Obj);
 private:
          void* readItem( ipstream& );
          void  writeItem( void *, opstream& );
};
/*-----------------------------------------------------------------*/
class THubListBox : public TListBox
{
 public:
                        THubListBox(const TRect& bounds, ushort aNumCols,
                                    TScrollBar* aScrollBar);
                   void shutDown();
                   void getText(char* dest, ccIndex item, short maxLen);
};
/*-----------------------------------------------------------------*/
class THubsDial : public TDialog
{
 public:
                THubsDial(TRect AR, char* ATitle);
           void shutDown();
           void handleEvent(TEvent& event);
           void sizeLimits(TPoint& min, TPoint& max);
           
           void Read();
           void Read1();
           bool Connect();

           char Go[81];
           char Addr[81];
 private:
 THubCollection* kol;
    TListBoxRec  dkol;
    THubListBox* LB;
    TInputLine*  Host;
    TInputLine*  Port;
};
/*-----------------------------------------------------------------*/
extern char LastServ[128];
void Servers();
/*-----------------------------------------------------------------*/
#endif
