/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * inifile.h: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/************************************************************************
* 1996
*************************************************************************/

#ifndef __INIFILE_H
#define __INIFILE_H

/*-----------------------------------------------------------------------*/
#include <stdio.h>

#define Uses_TObject
#include <tv.h>
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
class TINIfile : public TObject {
  public:
        TINIfile();
        TINIfile(bool Afullname);
   void shutDown();
   bool Read(char* file, char* section, char* item, char* value, char* defaultValue);
   bool Read(char* file, char* section, long item, char* value, char* defaultValue);
   bool Write(char* file, char* section, char* item, char* value);
   bool Write(char* file, char* section, long item, char* value);
   bool Delete(char* file, char* section, char* item);
   bool Delete(char* file, char* section, long item);

  private:

    char* inisection;
    char* iniitem;
    FILE* fd;
     int  mode;
    bool  fullname;

    void  Upper(char* strin, char* strout);
    void  Upper2(char* strin);
    void  Lower(char* strin, char* strout);
};
/*-----------------------------------------------------------------------*/
#endif

