/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * options.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "options.h"

/*-----------------------------------------------------------------*/
#include <string.h>
#include <stdlib.h>

#define Uses_THistory
#define Uses_MsgBox
#define Uses_TDialog
#define Uses_TInputLine
#define Uses_TLabel
#define Uses_TStaticText
#define Uses_TSItem
#define Uses_TButton
#define Uses_TCheckBoxes
#define Uses_TDeskTop
#define Uses_TView
#define Uses_TValidator
#include <tv.h>

#include "liczby.h"
#include "inifile.h"
#include "main.h"
#include "tools.h"

/*-----------------------------------------------------------------*/
TOptions  opt;
    char  beep_word[5][50];
   uchar  mx[20][2];
    FILE* f_log;
    FILE* f_deb;
    char  downloadDir[511];
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
void ReadOptions()
{
 TINIfile* ini;
     char  b1[81];
 
 ini = new TINIfile(true);

 ini->Read(cfgFile,"Options", "Nick",     opt.Nick,        "mynick");
 ini->Read(cfgFile,"Options", "Info",     opt.Info,        "myinfo");
 ini->Read(cfgFile,"Options", "Slots",    opt.Slots,       "3");
 char *s_tmp = NewStr(MAXMSG);
 strcpy2(s_tmp, getenv("HOME"));
 strcat2(s_tmp, "/VShare");
 ini->Read(cfgFile,"Options", "VShareDir",opt.VSharedDir,  s_tmp);
 DelStr(s_tmp);
 ini->Read(cfgFile,"Options", "HostIP",   opt.HostIP,      "");
 ini->Read(cfgFile,"Options", "HostPort", opt.HostPort,    "30000");
 ini->Read(cfgFile,"Options", "ConnType", opt.ConnType,    "Cable");
 ini->Read(cfgFile,"Options", "Offset",   opt.Offset,      "0");
 ini->Read(cfgFile,"Options", "Timeout",  opt.Timeout,     "10");
 ini->Read(cfgFile,"Options", "DCTC",     opt.Dctc,        "/usr/bin/");
 ini->Read(cfgFile,"Options", "Firewall", b1,              "0");
 opt.Firewall = Str2Ushort(b1);
 ini->Read(cfgFile,"Options", "DDL",      b1,               "0");
 opt.DDL      = Str2Ushort(b1);
 ini->Read(cfgFile,"Options", "MD5",      b1,               "0");
 opt.MD5      = Str2Ushort(b1);
 ini->Read(cfgFile,"Options", "Log",      b1,               "0");
 opt.Log      = Str2Ushort(b1);
 ini->Read(cfgFile,"Options", "Deb",      b1,               "0");
 opt.Deb      = Str2Ushort(b1);

 memset(&beep_word, 0x0, sizeof(beep_word));
 ini->Read(cfgFile,"Beeper", 1L, beep_word[0], "");
 ini->Read(cfgFile,"Beeper", 2L, beep_word[1], "");
 ini->Read(cfgFile,"Beeper", 3L, beep_word[2], "");
 ini->Read(cfgFile,"Beeper", 4L, beep_word[3], "");
 ini->Read(cfgFile,"Beeper", 5L, beep_word[4], "");

 memset(&mx, 0x0, sizeof(mx));
 for (uchar c=0; c<20; c++) {
   int c0, c1;
   ini->Read(cfgFile,"Chars", (long)(c+1), b1, "000|000");
   if (strlen(b1)==7) {
     sscanf(b1,"%03d|%03d", &c0, &c1);
     } else {
     c0=c1=0;
   }
   mx[c][0] = (unsigned char)c0;
   mx[c][1] = (unsigned char)c1;
 }

 s_tmp = NewStr(MAXMSG);
 strcpy2(s_tmp, getenv("HOME"));
 strcat2(s_tmp, "/.ldcc");
 ini->Read(cfgFile, "Download", 1L, downloadDir, s_tmp);
 DelStr(s_tmp);
 
 DCApp->destroy(ini);
}
/*-----------------------------------------------------------------*/
void DCOptions()
{
 TINIfile* ini;
     char  b1[81];
 
    TDialog* D;
 TInputLine* IL;
 TValidator* VL;
   THistory* H;
      TView* V;
     ushort  ret;
 
 D = new TDialog(TRect(0,0,60,23), "Options");
 D->options|= ofCentered;
 D->helpCtx = 40;

 IL = new TInputLine(TRect(20,2,42,3), 20);
 D->insert(IL);  V = IL;
 D->insert(new TLabel(TRect(2,2,19,3), "~N~ick:", IL));

 IL = new TInputLine(TRect(20,3,58,4), 40);
 D->insert(IL);
 D->insert(new TLabel(TRect(2,3,19,4), "~U~ser info:", IL));
 
 IL = new TInputLine(TRect(20,4,24,5), 2);
 IL->SetValidator(new TNumberValidator());
 D->insert(IL);
 D->insert(new TLabel(TRect(2,4,19,5), "~F~ree slots:", IL));

 IL = new TInputLine(TRect(20,6,58,7), 125);
 D->insert(IL);
 D->insert(new TLabel(TRect(2,6,19,8), "~V~irtual files dir:", IL));

 IL = new TInputLine(TRect(20,7,37,8), 16);
 D->insert(IL);
 D->insert(new TLabel(TRect(2,7,19,8), "~H~ost IP:", IL));
 
 IL = new TInputLine(TRect(20,8,27,9), 6);
 VL = new TRangeValidator(1L,65535L);
 IL->SetValidator(VL);
 D->insert(IL);
 D->insert(new TLabel(TRect(2,8,19,9), "Ho~s~t Port:", IL));

 IL = new TInputLine(TRect(20,9,31,10), 10);
 IL->SetValidator(new TEmptyValidator());
 H = new THistory(TRect(32,9,35,10), IL, 1);
 D->insert(H);
 historyAdd(1, "56Kbps");
 historyAdd(1, "33.6Kbps");
 historyAdd(1, "28.8Kbps");
 historyAdd(1, "Satellite");
 historyAdd(1, "ISDN");
 historyAdd(1, "DSL");
 historyAdd(1, "Cable");
 historyAdd(1, "LAN(T1)");
 historyAdd(1, "LAN(T3)");
 D->insert(IL);
 D->insert(new TLabel(TRect(2,9,20,10), "Connection ~t~ype:", IL));

 IL = new TInputLine(TRect(20,10,41,11), 20);
 IL->SetValidator(new TNumberValidator());
 D->insert(IL);
 D->insert(new TLabel(TRect(2,10,19,11), "Offs~e~t:", IL));
 D->insert(new TStaticText(TRect(42,10,50,11), "bytes"));

 IL = new TInputLine(TRect(20,11,24,12), 3);
 IL->SetValidator(new TNumberValidator());
 D->insert(IL);
 D->insert(new TLabel(TRect(2,11,20,12), "Connction ti~m~eout:", IL));
 D->insert(new TStaticText(TRect(25,11,30,12), "sec."));

 IL = new TInputLine(TRect(20,13,50,14), 80);
 D->insert(IL);
 D->insert(new TLabel(TRect(2,13,19,14), "~D~CTC path:", IL));

 D->insert(new TCheckBoxes(TRect(2,15,29,16), new TSItem("Behind Firewall",NULL)));
 D->insert(new TCheckBoxes(TRect(2,16,29,17), new TSItem("Enable DirectDownlaod",NULL)));
 D->insert(new TCheckBoxes(TRect(2,17,29,18), new TSItem("Dissable MD5 checksum",NULL)));

 D->insert(new TCheckBoxes(TRect(31,15,57,16), new TSItem("Log main chat",NULL)));
 D->insert(new TCheckBoxes(TRect(31,16,57,17), new TSItem("Log errors/debug",NULL)));

 IL = new TInputLine(TRect(28,19,34,20), 5);
 IL->SetValidator(new TNumberValidator());
 D->insert(IL);
 D->insert(new TLabel(TRect(2,19,27,20), "U~p~load bandwidth limit:", IL));
 D->insert(new TStaticText(TRect(35,19,45,20), "x 0,5 kB/s"));

 IL = new TInputLine(TRect(28,20,34,21), 5);
 IL->SetValidator(new TNumberValidator());
 D->insert(IL);
 D->insert(new TLabel(TRect(2,20,27,21), "Do~w~nload bandwidth limit:", IL));
 D->insert(new TStaticText(TRect(35,20,45,21), "x 1 kB/s"));

 D->insert(new TButton(TRect(46, 18, 58, 20), "~O~K",   cmOK,     bfDefault));
 D->insert(new TButton(TRect(46, 20, 58, 22), "Cancel", cmCancel, bfNormal));
 
 D->setData(&opt);
 D->setCurrent(V, (TView::selectMode)0);
 
 if (DCApp->validView(D)) {
   ret = DCApp->deskTop->execView(D);
   if (ret == cmOK) {
     D->getData(&opt);
     ini = new TINIfile(true);
     ini->Write(cfgFile,"Options", "Nick",      opt.Nick);
     ini->Write(cfgFile,"Options", "Info",      opt.Info);
     ini->Write(cfgFile,"Options", "Slots",     opt.Slots);
     ini->Write(cfgFile,"Options", "VShareDir", opt.VSharedDir);
     ini->Write(cfgFile,"Options", "HostIP",    opt.HostIP);
     ini->Write(cfgFile,"Options", "HostPort",  opt.HostPort);
     ini->Write(cfgFile,"Options", "ConnType",  opt.ConnType);
     ini->Write(cfgFile,"Options", "Offset",    opt.Offset);
     ini->Write(cfgFile,"Options", "Timeout",   opt.Timeout);
     ini->Write(cfgFile,"Options", "DCTC",      opt.Dctc);
     sprintf(b1, "%d", opt.Firewall); ini->Write(cfgFile,"Options", "Firewall", b1);
     sprintf(b1, "%d", opt.DDL);      ini->Write(cfgFile,"Options", "DDL",      b1);
     sprintf(b1, "%d", opt.MD5);      ini->Write(cfgFile,"Options", "MD5",      b1);
     sprintf(b1, "%d", opt.Log);      ini->Write(cfgFile,"Options", "Log",      b1);
     sprintf(b1, "%d", opt.Deb);      ini->Write(cfgFile,"Options", "Deb",      b1);
     ini->Write(cfgFile,"Options", "UBL",      opt.UBL);
     ini->Write(cfgFile,"Options", "DBL",      opt.DBL);
     DCApp->destroy(ini);

     if ((opt.Log==1)&&(f_log==NULL)) {
       f_log = fopen(logFile, "a+");
       if (f_log==NULL) {
         messageBox("\003Can't create log file.",mfError|mfOKButton);
         opt.Log=0;
       }
       } else {
       if (f_log!=NULL) {
         fclose(f_log);
         f_log=NULL;
       }
     }
   
     if ((opt.Deb==1)&&(f_deb==NULL)) {
       f_deb = fopen(debFile, "a+");
       if (f_deb==NULL) {
         messageBox("\003Can't create\n\003cerror/debug log file.",mfError|mfOKButton);
         opt.Deb=0;
       }
       } else {
       if (f_deb!=NULL) {
         fclose(f_deb);
         f_deb=NULL;
       }
     }
   }
 }

 DCApp->destroy(D);
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
void Beeper()
{
 TDialog* D;
   TView* V;
  ushort  ret;
 
 D = new TDialog(TRect(0,0,54,15), "Beeper");
 D->options |= ofCentered;
 D->helpCtx = 40;

 D->insert(new TStaticText(TRect(2,1,30,2), "Beep on words:"));
 D->insert(V = new TInputLine(TRect(2,2,53,3), 50));
 D->insert(new TInputLine(TRect(2,4,53,5), 50));
 D->insert(new TInputLine(TRect(2,6,53,7), 50));
 D->insert(new TInputLine(TRect(2,8,53,9), 50));
 D->insert(new TInputLine(TRect(2,10,53,11), 50));

 D->insert(new TButton(TRect(28,12,40,14), "~O~K",   cmOK,     bfDefault));
 D->insert(new TButton(TRect(40,12,52,14), "Cancel", cmCancel, bfNormal));

 D->setData(&beep_word);
 D->setCurrent(V, (TView::selectMode)0);
 
 if (DCApp->validView(D)) {
   ret = DCApp->deskTop->execView(D);
   if (ret==cmOK) {
     D->getData(&beep_word);

     TINIfile *ini;
     ini = new TINIfile(true);
     ini->Write(cfgFile,"Beeper", 1L, beep_word[0]);
     ini->Write(cfgFile,"Beeper", 2L, beep_word[1]);
     ini->Write(cfgFile,"Beeper", 3L, beep_word[2]);
     ini->Write(cfgFile,"Beeper", 4L, beep_word[3]);
     ini->Write(cfgFile,"Beeper", 5L, beep_word[4]);
     DCApp->destroy(ini);
   }
 }
 DCApp->destroy(D);
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
void Coverter()
{
    TDialog* D;
 TInputLine* IL;
     ushort  ret;
      uchar  c;
 struct {
   char d[20][2][4];
   } dane;
 
 D = new TDialog(TRect(0,0,55,16), " Character converter ");
 D->options |= ofCentered;
 D->helpCtx = 40;

 D->insert(new TStaticText(TRect(2,2,30,3), " Change chars from xxx to yyy (decimal)"));

 for (c=0; c<10; c++) {
   IL = new TInputLine(TRect(2,4+c,7,5+c), 4);
   IL->SetValidator(new TRangeValidator(0L, 255L));
   D->insert(IL);
   D->insert(new TStaticText(TRect(8,4+c,10,5+c), "->"));
   IL = new TInputLine(TRect(11,4+c,16,5+c), 4);
   IL->SetValidator(new TRangeValidator(0L, 255L));
   D->insert(IL);
 }
 for (c=0; c<10; c++) {
   IL = new TInputLine(TRect(22,4+c,27,5+c), 4);
   IL->SetValidator(new TRangeValidator(0L, 255L));
   D->insert(IL);
   D->insert(new TStaticText(TRect(28,4+c,30,5+c), "->"));
   IL = new TInputLine(TRect(31,4+c,36,5+c), 4);
   IL->SetValidator(new TRangeValidator(0L, 255L));
   D->insert(IL);
 }

 D->insert(new TButton(TRect(42,11,53,13), "~O~K",   cmOK,     bfDefault));
 D->insert(new TButton(TRect(42,13,53,15), "Cancel", cmCancel, bfNormal));

 memset(&dane, 0x0, sizeof(dane));
 for (c=0; c<20; c++) {
   if (mx[c][0]!=0) sprintf(dane.d[c][0],"%d", mx[c][0]);
               else strcpy(dane.d[c][0], "0");
   if (mx[c][1]!=0) sprintf(dane.d[c][1],"%d", mx[c][1]);
               else strcpy(dane.d[c][1], "0");
 }

 D->setData(&dane);
 if (DCApp->validView(D)) {
   ret = DCApp->deskTop->execView(D);
   if (ret==cmOK) {
     D->getData(&dane);
     
     TINIfile* ini;
         char  b1[81];
 
     ini = new TINIfile(true);
     for (uchar c=0; c<20; c++) {
       char b1[21];
       ushort c1,c2;
       c1 = Str2Ushort(dane.d[c][0]);
       c2 = Str2Ushort(dane.d[c][1]);
       sprintf(b1,"%03d|%03d", c1, c2);
       ini->Write(cfgFile,"Chars", (long)(c+1), b1);
       mx[c][0] = (unsigned char)c1;
       mx[c][1] = (unsigned char)c2;
     }
     DCApp->destroy(ini);
   }
 }
 DCApp->destroy(D);
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
void Favorite()
{
    TDialog* D;
 TInputLine* IL;
     ushort  ret;
      uchar  c;
       char  no[5];
   TINIfile* ini;
       char  buf[256];
 struct {
   char d[11][31];
   } dane;
 
 D = new TDialog(TRect(0,0,39,17), "Favorite HUBs");
 D->options |= ofCentered;
 D->helpCtx = 40;

 D->insert(new TStaticText(TRect(5,2,30,3), "Put address or IP"));

 for (c=0; c<10; c++) {
   IL = new TInputLine(TRect(5,3+c,36,4+c), 31);
   D->insert(IL);
   sprintf(no,"%02d.",c+1);
   D->insert(new TStaticText(TRect(2,3+c,4,4+c), no));
 }

 D->insert(new TButton(TRect(10,14,22,16), "~O~K",   cmOK,     bfDefault));
 D->insert(new TButton(TRect(22,14,34,16), "Cancel", cmCancel, bfNormal));

 memset(&dane, 0x0, sizeof(dane));
 ini = new TINIfile(true);
 for (int n=1; n<11;n++) {
   ini->Read(cfgFile,"Hosts", n, buf, "");
   if (buf[0]!='\0') strcpy(dane.d[n-1],buf);
 }
 DCApp->destroy(ini);

 D->setData(&dane);
 if (DCApp->validView(D)) {
   ret = DCApp->deskTop->execView(D);
   if (ret==cmOK) {
     D->getData(&dane);
     ini = new TINIfile(true);
     for (int n=1; n<11;n++) {
      ini->Write(cfgFile,"Hosts", n, dane.d[n-1]);
     }
     DCApp->destroy(ini);
   }
 }

 DCApp->destroy(D);
}
/*-----------------------------------------------------------------*/

