/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * progress.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "progress.h"

/*-----------------------------------------------------------------*/
#include <string.h>

#define Uses_TDeskTop
#define Uses_TKeys
#define Uses_TEvent
#include <tv.h>

#include "main.h"
#include "liczby.h"
#include "options.h"
#include "search.h"
/*-----------------------------------------------------------------*/
double mytrunc(double d)
{
 char   ds[51];
 double dout;
 
 sprintf(ds,"%.2lf",d);
 int l = strlen(ds);
 ds[l-1]='0';
 ds[l-2]='0';
 sscanf(ds,"%lf", &dout);
 return dout;
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
//              class TProgBarDial : public TDialog
/*-----------------------------------------------------------------*/
TProgBarDial::TProgBarDial(TRect AR, char* AT, THUB* AMain)
             :TDialog(AR, AT),TWindowInit(TDialog::initFrame)
{
 Main    = AMain;
 helpCtx = 20;
 
 kol = new TObjCollection(10, 10);
 TScrollBar* SB;
 SB = new TScrollBar(TRect(78,1,79,11));
 insert(SB);
 LB = new TPBListBox(TRect(1,1,78,11), 1, SB);
 insert(LB);

 dkol.items     = kol;
 dkol.selection = 0;
 LB->setData(&dkol);

 time(&lasttest);
}
/*-----------------------------------------------------------------*/
void TProgBarDial::shutDown()
{
 if (kol!=NULL) destroy(kol);
 TDialog::shutDown();
}
/*-----------------------------------------------------------------*/
void TProgBarDial::AddMessage(char* Message)
{
    char* p;
    char  b[MAXMSG];
     int  poz, poz1;
 TPBItem* Item;
 TPBItem* Item1;
 ushort   i;

 if (strlen(Message)<12) return;
 
 p = (char*)(Message+9);

 Item = new TPBItem();

 //--- GDL ID
 strcpy(b, NextItem(p));
 // -- pomijamy - nie jest nam potrzebne

 //--- nazwa pliku
 strcpy(b, NextItem(p));
 Item->FileName = NewStr(b);

 //--- wielkosc pliku
 strcpy(b, NextItem(p));
 Item->Size = Str2Long(b);

 //--- offset
 strcpy(b, NextItem(p));
 // -- pomijamy - nie jest nam potrzebne
 
 // ilosc pobranych bajtow
 strcpy(b, NextItem(p));
 Item->Received = Str2Long(b);

 // start time
 strcpy(b, NextItem(p));
 // -- pomijamy - nie jest nam potrzebne

 // ilosc pobranych bajtow w ciagu ostatnich 10 sek.
 strcpy(b, NextItem(p));
 Item->Speed = Str2Long(b);
 Item->Speed = Item->Speed/10240.0;

 // sprawdz czy plik o tej nazwie juz jest w kolekcji
 bool notfound = true;
 for (i=0; (i<kol->getCount())&&(notfound); i++) {
   Item1 = (TPBItem*)kol->at(i);
   if (strcmp2(Item->FileName,Item1->FileName)==0) {
     Item1->Received = Item->Received;
     Item1->Speed    += Item->Speed;
     destroy(Item);
     notfound = false;
   }
 }
 if (notfound) {
   kol->insert(Item);
 }

 LB->setRange(kol->getCount());
 LB->focusItem(kol->getCount()-1);
 if (DCApp->deskTop->current==this) {
   LB->draw();
 }
}
/*-----------------------------------------------------------------*/
void TProgBarDial::Setup()
{
 kol->removeAll();
 LB->setRange(0);
 LB->focusItem(0);
// LB->Redraw();
 Update();
}
/*-----------------------------------------------------------------*/
void TProgBarDial::Update()
{
 char b[21];

 sprintf(b,"/GDLLST\n");

 Main->SendMsg(b);
 time(&lasttest);
 
 for (ushort i=0; i<kol->getCount(); i++) {
   TPBItem* Item = (TPBItem*)kol->at(i);
   //Item->Received = 0L;
   Item->Speed    = 0L;
 }
}
/*-----------------------------------------------------------------*/
void TProgBarDial::idle()
{
 time_t t1;
 time(&t1);
 if (t1-lasttest>5)
   Update();
}
/*-----------------------------------------------------------------*/
void TProgBarDial::handleEvent(TEvent& event)
{
 if (event.what==evNothing)
   idle();
   
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF6:
     case kbEnter:
                  event.what            = evCommand;
                  event.message.command = cmCancel;
                  break;
   }
 }
 TDialog::handleEvent(event);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
// class TPBItem : public TObject
/*-----------------------------------------------------------------*/
TPBItem::TPBItem():TObject()
{
 FileName = NULL;
 Size     = 0L;
 Received = 0L;
 Speed    = 0.0;
}
/*-----------------------------------------------------------------*/
void TPBItem::shutDown()
{
 DelStr(FileName);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
// class TPBListBox : public TListBox
/*-----------------------------------------------------------------*/
TPBListBox::TPBListBox(TRect AR, ushort AC, TScrollBar* SB)
           :TListBox(AR, AC, SB)
{
}
/*-----------------------------------------------------------------*/
void TPBListBox::shutDown()
{
 TListBox::shutDown();
}
/*-----------------------------------------------------------------*/
void TPBListBox::getText(char* dest, ccIndex item, short maxLen)
{
 TPBItem* I;
    char  s[512];
    char  s2[128];
  double  done;

 I = (TPBItem*)items->at(item);

 if (I->Size != 0.0) {
   done = (double)I->Received*100.0/(double)I->Size;
   } else {
   done = 0.0;
 }
 if (I->FileName!=NULL) {
   strcpy2(s2,I->FileName); s2[34]='\0';
   } else {
   s2[0]='\0';
 }

 if (I->Speed!=0.0) {
   double left = (double)(I->Size - I->Received);
   double h,m,sec;
   sec   = (left/1024.0)/I->Speed;
   
   h     = mytrunc(sec/3600.0);
   sec  -= h*3600.0;
   m     = mytrunc(sec/60.0);
   sec  -= m*60.0;

   sprintf(s, "%-34s%c%6.2lf%% done%c%6.2lf kB/s%c%02.0lf:%02.0lf:%02.0lf",
              s2, columnSeparator,
              done, columnSeparator,
              I->Speed, columnSeparator,
              h,m,sec);
   } else {
   sprintf(s, "%-34s%c%6.2lf%% done%c%6.2lf kB/s%c--:--:--",
              s2, columnSeparator,
              done, columnSeparator,
              I->Speed, columnSeparator);
 }
 s[(maxLen<512?maxLen:512)]='\0';
 strcpy(dest,s);
}
/*-----------------------------------------------------------------*/

