/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * search.cc: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "search.h"
/*-----------------------------------------------------------------*/
#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>
#include <dirent.h>

#define Uses_TDeskTop
#define Uses_TKeys
#define Uses_TEvent
#define Uses_TLabel
#define Uses_TButton
#define Uses_TRect
#define Uses_MsgBox
#include <tv.h>

#include "main.h"
#include "liczby.h"
#include "d_error.h"
#include "progress.h"
#include "options.h"
#include "gdl.h"
#include "tools.h"
#include "const.h"
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
      char LastSearch[128];
THUB_TABLE HUB_TABLE[MAX_HUB_TABLE];
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
void InsertHUB(char* ATitle, char* Addr, bool newHub)
{
 THUB* D;
 uchar myNo = MAX_HUB_TABLE+1;
 
 // --- check table
 for (uchar i=0; i<MAX_HUB_TABLE; i++) {
   if (HUB_TABLE[i].Dialog==NULL) {
     myNo = i;
     break;
   }
 }
 if (myNo==(MAX_HUB_TABLE+1)) {
   messageBox("\003Too many windows...", mfError|mfOKButton);
   return;
 }

 D = new THUB(TRect(0,0,80,23), ATitle, Addr, myNo);

 if (!D->Connect(newHub)) {
   DCApp->destroy(D);
   return;
 }

 D->GetGDLList();
 if (DCApp->validView(D))
   DCApp->deskTop->insert(D);

}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//                  class THUB : public TDialog
/*-----------------------------------------------------------------*/
THUB::THUB(TRect AR, char* ATitle, char* AAddr, uchar amyNo)
     :TDialog(AR, ATitle),TWindowInit(TDialog::initFrame)
{
 helpCtx = 10;
 options |= ofCentered;
 flags   |= wfGrow|wfZoom;
 myNo    = amyNo;
 wndMode = wmNormal;
 
 // --- Register in table
 HUB_TABLE[myNo].Dialog = this;

 connected = false;
 Addr      = NewStr(AAddr);

 TView *V;

 LB_Msg = new TListBox(TRect(1,1,79,7), 1, NULL);
 LB_Msg->growMode = gfGrowHiX|gfGrowHiY;
 insert(LB_Msg);

 CHAT = new TInputLine(TRect(16,7,78,8), 100);
 CHAT->growMode = gfGrowHiY|gfGrowLoY|gfGrowHiX;
 insert(CHAT);
 
 insert(V = new TLabel(TRect(2,7,15,8), "C~H~AT message:", CHAT));
 V->growMode = gfGrowHiY|gfGrowLoY;//|gfGrowRel;

 LB_Srch = new TSrchListBox(TRect(1,9,79,13), 1, NULL);
 LB_Srch->growMode = gfGrowHiY|gfGrowLoY|gfGrowHiX;
 insert(LB_Srch);
 insert(V = new TLabel(TRect(2,8,79,9),"Last serach ~r~esults: size           filename", LB_Srch));
 V->growMode = gfGrowHiY|gfGrowLoY;

 SIL = new TInputLine(TRect(48,13,78,14), 20);
 SIL->growMode = gfGrowHiY|gfGrowLoY|gfGrowHiX;
 insert(SIL);
 SIL->setData(LastSearch);
 insert(SL = new TLabel(TRect(40,13,47,14), "S~e~arch:", SIL));
 SL->growMode = gfGrowHiY|gfGrowLoY;

 LB_Rest = new TUsrListBox(TRect(1,14,38,22), 1, NULL);
 LB_Rest->growMode = gfGrowHiY|gfGrowLoY;
 insert(LB_Rest);

 LB_GDL = new TGDLListBox(TRect(40,15,78,22), 1, NULL);
 LB_GDL->growMode = gfGrowHiY|gfGrowLoY|gfGrowHiX;
 insert(LB_GDL);
 
 kol_Msg = new TNSStringCollection(10,10);
 dkol_Msg.items     = kol_Msg;
 dkol_Msg.selection = 0;
 LB_Msg->setData(&dkol_Msg);

 kol_Srch = new TObjCollection(10,10);
 dkol_Srch.items     = kol_Srch;
 dkol_Srch.selection = 0;
 LB_Srch->setData(&dkol_Srch);

 kol_Rest = new TUsrColl(50, 10);
 dkol_Rest.items     = kol_Rest;
 dkol_Rest.selection = 0;
 LB_Rest->setData(&dkol_Rest);

 GDL = new TGDL(this);

 UsersST = new TMyStaticText(TRect(2,13,38,14), "Users: ---- Shared ------TB         ");
 UsersST->growMode = gfGrowHiY|gfGrowLoY;
 
 insert(UsersST);
 Total_Users  = 0;
 Total_Shared = 0.0;

 // SelectView(SIL);

 DError   = new TErrorDial(TRect(0,0,80,12)," Errors ", this);
 DAuto    = new TAutoDial(TRect(0,0,80,12), " Auto resume ", this);
 DOther   = new TOtherDial(TRect(0,0,80,12)," Other messages ", this);
 DPChat   = new TPChatDial(TRect(0,0,80,12)," Private chats ", this);
 DAdvSrch = new TAdvSrchDial(TRect(0,0,80,12)," Advenced search options ", this);

 DProgBar = new TProgBarDial(TRect(0,0,80,12)," Download/Upload status ", this);

 // Set default values for search window
 memset(&DAdvSrch->sdata, 0x0, sizeof(DAdvSrch->sdata));
 DAdvSrch->sdata.Operator=1;
 DAdvSrch->sdata.FreeSlot=1;
 DAdvSrch->setData(&DAdvSrch->sdata);

 insert(V = new TStaticText(TRect(66,22,78,23), " [Esc] Exit "));
 V->growMode = gfGrowAll;

 char b[7];
 sprintf(b," [%d] ", (int)myNo);
 insert(V = new TStaticText(TRect(2,22,7,23),b));
 V->growMode = gfGrowHiY|gfGrowLoY;
 
 Socket = new TSocket();
}
/*-----------------------------------------------------------------*/
void THUB::shutDown()
{
 if (connected) Disconnect();

 TDialog::shutDown();

 DelStr(Addr);
 
 if (kol_Msg!=NULL)  destroy(kol_Msg);
 if (kol_Srch!=NULL) destroy(kol_Srch);
 if (kol_Rest!=NULL) destroy(kol_Rest);

 destroy(DError);
 destroy(DAuto);
 destroy(DOther);
 destroy(DPChat);
 destroy(DAdvSrch);
 destroy(DProgBar);
 
 destroy(GDL);
 destroy(Socket);
 // --- Unregister from table
 HUB_TABLE[myNo].Dialog = NULL;
}
/*-----------------------------------------------------------------*/
void THUB::sizeLimits(TPoint& min, TPoint& max)
{
 min.x = 80;
 min.y = 23;
 if (owner!=0) {
   max = owner->size;
   } else {
   max.x = max.y = INT_MAX;
 }
}
/*-----------------------------------------------------------------*/
void THUB::handleEvent(TEvent& event)
{
 if (event.what==evKeyDown) {
   if (event.keyDown.keyCode==kbEnter) {
     clearEvent(event);
     EnterHandle();
   }
 }
 
 if (event.what==evKeyDown) {
   if (event.keyDown.keyCode==kbEsc) {
     clearEvent(event);
     if ( messageBox("\003Close HUB window ?", mfConfirmation|mfYesButton|mfNoButton)!=cmYes ) {
       return;
     }
     event.what = evCommand;
     event.message.command = cmClose;
     event.message.infoPtr = this;
   }
 }

 /*
 if (event.what==evKeyDown) {
   switch (event.keyDown.keyCode) {
     case kbF1: LunchWnd(DOther);   return;
     case kbF2: LunchWnd(DAuto);    return;
     case kbF3: LunchWnd(DPChat);   return;
     case kbF4: LunchWnd(DError);   return;
     case kbF5: Command();          return;
     case kbF6: DProgBar->Setup(); LunchWnd(DProgBar); return;
     case kbF7: Extra();            return;
   }
 }
 */
 
 TDialog::handleEvent(event);

 if (event.what==evCommand) {
   switch (event.message.command) {
     case cmSearch:    Search();                break;
     case cmWndMode:   ChangeMode();            break;
     case cmWndOther:  LunchWnd(DOther);        break;
     case cmWndAuto:   LunchWnd(DAuto);         break;
     case cmWndPriv:   LunchWnd(DPChat);        break;
     case cmWndErrors: LunchWnd(DError);        break;
     case cmWndComm:   Command();               break;
     case cmWndStat:   DProgBar->Setup();
                       LunchWnd(DProgBar);      break;
     case cmWndExtra:  Extra();                 break;
     default:                                   return;
   }
   clearEvent(event);
 }
}
/*-----------------------------------------------------------------*/
void THUB::ChangeMode()
{
 TRect R,R1;

 R  = LB_Srch->getBounds();
 R1 = getBounds();
 
 if (wndMode == wmNormal ) {
   setCurrent(LB_Srch, (TView::selectMode)0);
   SIL->hide();
   SL->hide();
   LB_Rest->hide();
   LB_GDL->hide();
   UsersST->hide();
   R.b.y = R1.b.y - 1;
   wndMode = wmZoom;
   
   } else {

   SIL->show();
   SL->show();
   LB_Rest->show();
   LB_GDL->show();
   UsersST->show();
   R.b.y = R.a.y + 4;
   wndMode = wmNormal;
 }

 LB_Srch->setBounds(R);
// LB_Srch->drawView();
 Redraw();
}
/*-----------------------------------------------------------------*/
void THUB::Search()
{
 char s[81];
 SIL->getData(s);

 if (s[0]=='\0') return;

 kol_Srch            = new TObjCollection(10,10);
 dkol_Srch.items     = kol_Srch;
 dkol_Srch.selection = 0;
 LB_Srch->setData(&dkol_Srch);
 LB_Srch->setRange(0);
 LB_Srch->focusItem(0);
 LB_Srch->draw();

 DAdvSrch->IL[0]->setData(s);

 LunchWnd(DAdvSrch);

 DAdvSrch->getData(&DAdvSrch->sdata);
 
 strcpy2(LastSearch, DAdvSrch->sdata.s[0]);
 SIL->setData(LastSearch);
 SIL->draw();

 for (uchar n=0; n<4; n++) {
   if (DAdvSrch->sdata.s[n][0]!='\0') {
     sprintf(command, "/SRCH *%s*%d", DAdvSrch->sdata.s[n], DAdvSrch->sdata.Type+1);
     if ((DAdvSrch->sdata.SizeType!=0) && DAdvSrch->sdata.Size[0]!='\0') {
       sprintf(s,"*%c*s\n", (DAdvSrch->sdata.SizeType==1?'L':'M'), DAdvSrch->sdata.Size);
       } else {
       sprintf(s,"\n");
     }
     strcat(command, s);
     SendMsg(command);
     usleep(1000000L);
   }
 }
 /*
 strcpy(LastSearch, s);
 sprintf(command, "/SRCH *%s*1\n", s);
 SendMsg(command);
 */
 DOther->AddMessage("CLIENT> SEARCH QUEUED", false);
}
/*-----------------------------------------------------------------*/
void THUB::idle()
{
 Read();
}
/*-----------------------------------------------------------------*/
bool THUB::Connect(bool newHub)
{
 bool notfound = true;
 long lmax;

 if (opt.Timeout[0]!='\0') {
   sscanf(opt.Timeout,"%ld",&lmax);
   } else {
   lmax=10L;
 }

 dctc_path = NewStr(MAXMSG);
 strcpy2(dctc_path, getenv("HOME"));
 strcat2(dctc_path, "/.dctc/running/dctc-");
 strcat2(dctc_path, Addr);

 do {
   long   l=0L;
   
   WaitON(True, "Connecting... [ESC abort]");
   WaitUpdate(lmax, l);
   while ((l<lmax)&&notfound) {

     int ret;
     if (newHub) ret = CheckNewHub();
           else  ret = access(dctc_path, X_OK);
           
     if (ret!=0) {
       l++;
       WaitUpdate(lmax,l);
       usleep(1000000L);
       TEvent event;
       DCApp->getEvent(event);
       if (event.what==evKeyDown) {
         if (event.keyDown.keyCode==kbEsc) {
           DCApp->clearEvent(event);
           break;
         }
       }
       } else {
       notfound = false;
     }
   }
   WaitOFF();
   if (notfound) {
     ushort r = messageBox("\003Timeout!\n\003Try again ?", mfConfirmation|mfYesButton|mfNoButton);
     if (r!=cmYes) {
       // sprintf(command,"pkill -9 -f %s", Addr);
       // system(command);
       DelStr(dctc_path);
       return false;
     }
   }
 } while (notfound);
 
 connected = Socket->Open(dctc_path, !newHub);
 DelStr(dctc_path);
 return connected;
}
/*------------------------------------------------------------------*/
int THUB::CheckNewHub()
{
          char* path1;
           DIR* dir;
 struct dirent* obj;
           int  a;

 path1 = NewStr(MAXMSG);
 strcpy2(path1, getenv("HOME"));
 strcat2(path1, "/.dctc/running");

 dir=opendir(path1);
 if(dir!=NULL) {
   while((obj=readdir(dir))!=NULL) {
     if (strncmp(obj->d_name,"dctc-",5)==0) {
       a=strlen(obj->d_name);
       if (a>9) {
         if (strcmp(obj->d_name+a-4,".udp")!=0) {
           if (strcmp(obj->d_name+a-5,".done")!=0) {
             if (strcmp(obj->d_name+a-9,".userinfo")!=0) {
               //found a socket
               char s1_tmp[81];
               strcpy2(s1_tmp, (char*)(obj->d_name+5+9));
               if (strcmp2(s1_tmp, Addr)==0) {
                  strcpy2(dctc_path, path1);
                  strcat2(dctc_path, "/");
                  strcat2(dctc_path, obj->d_name);
                  closedir(dir);
                  DelStr(path1);
                  return 0;
               }
             }
           }
         }
       }
     }
   }
   } else { // if (dir!=NULL)
   // messageBox("\003Unable to dctc running path", mfError|mfOKButton);
   return -1;
 }
 closedir(dir);
 DelStr(path1);
 return -1;
}
/*------------------------------------------------------------------*/
void THUB::Disconnect()
{
 ushort ret=messageBox("\003Close dctc server ?", mfConfirmation|mfYesButton|mfNoButton);
 if (ret!=cmYes) {
   Socket->Close();
   return;
 }

 strcpy(command,"/FORCEQUIT\n");
 SendMsg(command);

 WaitON();
 usleep(3000000);
 WaitOFF();
 Socket->Close();
}
/*------------------------------------------------------------------*/
void THUB::Read()
{
 /*
         fd_set rfds;
 struct timeval tv;
            int retval;
 */
 
 char message[MAXMSG];
 Socket->Read(message);
 
 if (strlen(message)<6) return;

     
     if (strncmp(message,"CHAT ]",6)==0) Add_Msg(1, message);
       else if (strncmp(message,"PRIV ]",6)==0) PrivMessage(message);
        else if (strncmp(message,"INFO ]",6)==0) Add_Msg(2, message);
         else if(strncmp(message,"ERR  ]",6)==0) DError->AddMessage(message);
          else if(strncmp(message,"HUBNM]",6)==0) Add_Msg(3, message);
           else if(strncmp(message,"PRIV ]",6)==0) Add_Msg(4, message);
            else if(strncmp(message,"HUBGO]",6)==0) Add_Msg(5, message);
             else if(strncmp(message,"$DL+ ]",6)==0) Add_Msg(6, message);
              else if(strncmp(message,"$DL- ]",6)==0) Add_Msg(7, message);
               else if(strncmp(message,"$DL# ]",6)==0) Add_Msg(8, message);
                else if(strncmp(message,"$DL~ ]",6)==0) Add_Msg(9, message);
                 else if(strncmp(message,"ASTRT]",6)==0) DAuto->AddMessage(message);
                   else if(strncmp(message,"$DL= ]",6)==0) Add_Msg(11, message);
                    else if(strncmp(message,"HUB- ]",6)==0) Add_Msg(12, message);
                      else if(strncmp(message,"HUB+ ]",6)==0) Add_Msg(13, message);

              else if (strncmp(message,"GLSTC]",6)==0) DProgBar->AddMessage(message);
              
              else if (strncmp(message,"SREST]",6)==0) Add_Srch(message);

              else if (strncmp(message,"USER ]",6)==0) Add_Rest(1, message);
               else if (strncmp(message,"USER+]",6)==0) Add_Rest(2, message);
                else if (strncmp(message,"USER-]",6)==0) Add_Rest(3, message);
                 else if (strncmp(message,"UINFO]",6)==0) Add_Rest(4, message);
                  else if (strncmp(message,"OP   ]",6)==0) Add_Op(message);

               else if (strncmp(message,"VAR  ]",6)==0) Add_VAR(message);
                else if (strncmp(message,"GQLSC]",6)==0) Add_Xfer(1,message);

               else if (strncmp(message,"FLST ]",6)==0) Add_LS(message);

               else DOther->AddMessage(message, false);
}
/*-----------------------------------------------------------------*/
void THUB::PrivMessage(char *Msg)
{
 DPChat->AddMessage(Msg);
 if (DCApp->deskTop->current==this) LunchWnd(DPChat);
}
/*-----------------------------------------------------------------*/
void THUB::Add_Msg(int M,char *Msg)
{
 if (kol_Msg->getCount() > 500 ) {
   for (uchar i=0; i<10;i++) {
     kol_Msg->atRemove(0);
   }
 }

 ConvMsg(Msg);
 
 char s[MAXMSG], t[10];
 switch (M) {
   case 1: strcpy(t,GetTime()); t[5]='\0'; sprintf(s, "%s%s", t, (char*)(Msg+9)); break;
   case 2: { // dissable some messages
             char *ss = (char*)(Msg+8);
             if (strstr(ss, "hub_disconnect") == ss) return;
             if (strstr(ss, "\"/LS in $Rev") == ss) return;
             if (strstr(ss, "type\"$Get") == ss) return;
             strcpy2(s,"STATUS!> "); strcat2(s,ss);
           }
           break;
   case 3: strcpy(s,"HUB NAME> "); strcat(s,(char*)(Msg+9)); break;
   case 4: strcpy(s,"PRIVATE> "); strcat(s,(char*)(Msg+9)); break;
   case 5: strcpy(s,"REDIRECT> "); strcat(s,(char*)(Msg+9)); break;
   case 6: strcpy(s,"DOWNLOAD START> "); strcat(s,(char*)(Msg+9)); break;
   case 7: strcpy(s,"DOWNLOAD SUCCESSFULL> "); strcat(s,(char*)(Msg+9)); break;
   case 8: strcpy(s,"DOWNLOAD ERROR> "); strcat(s,(char*)(Msg+9)); break;
   case 9: strcpy(s,"DOWNLOAD PROBLEM> "); strcat(s,(char*)(Msg+9)); break;
   case 11: strcpy(s,"DOWNLOAD IN PROGRESS> "); strcat(s,(char*)(Msg+9)); break;
   case 12: strcpy(s,"! DISCONNECTED> ");
            printf("%c", 0x7);
            strcat(s,(char*)(Msg+9));
            printf("%c", 0x7);
            printf("%c", 0x7);
            // clear user list
	    LB_Rest->focusItem(0);
	    LB_Rest->setRange(0);
            kol_Rest->removeAll();
            Total_Users=0L;
            Total_Shared=0.0;
            break;
   case 13: strcpy(s,"! CONNECTED> ");
            strcat(s,(char*)(Msg+9));
            // Do commands!
            if (opt.UBL[0]!='\0') {
              sprintf(command,"/UBL %s\n", opt.UBL);
              SendMsg(command);
            }
            if (opt.DBL[0]!='\0') {
              sprintf(command,"/DBL %s\n", opt.UBL);
              SendMsg(command);
            }
            
            break;
   //case 100:strcpy(s,"OTHER CM> "); strcat(s,(char*)(Msg+9)); break;
 }

 // check LB_Msg width
 int width = LB_Msg->size.x - 1;

 while (strlen(s)>width) {
   char s1[MAXMSG], s2[MAXMSG];
   strncpy(s1, s, width); s1[width]='\0';
   kol_Msg->insert(NewStr(s1));
   if (f_log!=NULL) {
     fprintf(f_log,"%s\n", s1);
     fflush(f_log);
   }
   strcpy2(s2, (char*)(s+width));
   strcpy2(s, s2);
 }
 if (strlen(s)>0) {
   kol_Msg->insert(NewStr(s));
   if (f_log!=NULL) {
     fprintf(f_log,"%s\n", s);
     fflush(f_log);
   }
 }
 if (f_log!=NULL) {
   fprintf(f_log,"----------------------------------------------------------\n", s);
   fflush(f_log);
 }

 ushort r = kol_Msg->getCount();
 LB_Msg->setRange(r);
 if (r>0) LB_Msg->focusItem(r-1);
     else LB_Msg->focusItem(0);

 // BEEPER
 if (strstr((char*)(Msg+9), opt.Nick)!=NULL)
   printf("%c", 0x7);
 for (uchar b=0;b<5;b++) {
   if (beep_word[b][0]!='\0') {
     if (strstr((char*)(Msg+9), beep_word[b])!=NULL) {
       printf("%c", 0x7); fflush(stdout); usleep(50000);
       printf("%c", 0x7); fflush(stdout); usleep(50000);
       printf("%c", 0x7); fflush(stdout);
     }
   }
 }
 
}
/*-----------------------------------------------------------------*/
void THUB::Add_Xfer(int M,char *Msg)
{
 GDL->TestActive(Msg);
 LB_GDL->draw();
}
/*-----------------------------------------------------------------*/
void THUB::Add_Op(char *Msg)
{
     char* p;
     char  b[MAXMSG];
 TUsrItem* Item;
     bool  found;
   ushort  n;

 if (strlen(Msg)<10) return;
 
 //--- operator nick
 p = (char*)(Msg+9);
 strcpy2(b, NextItem(p));
 if (strlen2(b)==0) return;

 //--- is on list ?
 found = false;
 for (n=0;n<kol_Rest->getCount();n++) {
   Item = (TUsrItem*)kol_Rest->at(n);
   if (strstr(b, Item->Nick)==b) {
     Item->Op = true;
     found    = true;
     break;
   }
 }
 if (!found) {
   Item = new TUsrItem();
   Item->Nick  = NewStr(b);
   Item->Share = 0.0;
   Item->Connection = NewStr("???");
   Item->Op = true;
   ChangeUser(2, 0.0);
   kol_Rest->insert(Item);
 }

 ushort r = kol_Rest->getCount();
 LB_Rest->setRange(r);
}
/*-----------------------------------------------------------------*/
void THUB::Add_Srch(char *Msg)
{
      char* p;
      char  b[MAXMSG];
       int  poz, poz1;
 TSrchItem* Item;
    ushort  i;
 
 // DEB2(Msg, "SRCH RESULT:");
 p = (char*)(Msg+9);

 Item = new TSrchItem();

 //--- Nick
 strcpy(b, NextItem(p));
 Item->Nick = NewStr(b);

 if (strncmp(Item->Nick,"[DK]zAic",8)==0) {
   i=0;
 }
 //--- Path
 strcpy(b, NextItem(p));
 Item->Path = NewStr(b);

 //--- Size
 strcpy(b, NextItem(p));
 Item->Size = Str2Long(b);

 //--- FreeSlots
 strcpy(b, NextItemDenom(p,'/'));
 Item->Slot_Free = Str2Uchar(b);

 //--- TotalSlots
 strcpy(b, NextItem(p));
 Item->Slot_Total = Str2Uchar(b);

 //--- Extract filename from full path
 poz = 0;
 poz1= 0;
 p = Item->Path;
 while (*p!='\0') {
   if (*p=='\\') poz1 = poz;
   poz++;
   p++;
 }
 Item->File = NewStr( (char*)(Item->Path+poz1+1) );

 // Check filter parameters
 if ( DAdvSrch->sdata.FreeSlot == 1 ) {
   if (Item->Slot_Free==0) {
         destroy(Item);
         return;
   }
 }

 if ( DAdvSrch->sdata.Operator == 1 ) { // AND
   for (uchar n=0; n<4; n++) {
     if (DAdvSrch->sdata.s[n][0]!='\0') {
       char a1[21], a2[MAXMSG];
       char *z, *z1;
       z = DAdvSrch->sdata.s[n]; z1 = a1;
       while ( *z!='\0' ) { *z1 = toupper(*z); z1++; z++; }
       *z1 = '\0';

       z = Item->Path; z1 = a2;
       while ( *z!='\0' ) { *z1 = toupper(*z); z1++; z++; }
       *z1 = '\0';
       
       if (strstr(a2,a1)==NULL ) {
         destroy(Item);
         return;
       }
     }
   }
 }

 // Check the same results
 bool notfound = true;
 for (i=0; i< kol_Srch->getCount(); i++) {
   TSrchItem *Item2 = (TSrchItem *)kol_Srch->at(i);
   if ( (strcmp2(Item->Nick,Item2->Nick)==0) &&
        (strcmp2(Item->Path, Item2->Path)==0) ) {
      destroy(Item);
      return;
   }
 }

 // Check operators;
 for (i=0; i< kol_Rest->getCount(); i++) {
   TUsrItem *UItem = (TUsrItem *)kol_Rest->at(i);
   if (strcmp2(UItem->Nick,Item->Nick)==0) {
     if (UItem->Op) Item->Op=true;
     break;
   }
 }
 
 kol_Srch->insert(Item);

 ushort r = kol_Srch->getCount();
 LB_Srch->setRange(r);
 if (r>0) LB_Srch->focusItem(r-1);
     else LB_Srch->focusItem(0);
 LB_Srch->draw();
}
/*-----------------------------------------------------------------*/
void THUB::Add_LS(char *Msg)
{
      char* p;
      char  b[MAXMSG];
       int  poz, poz1;
 TSrchItem* Item;
    ushort  i;
 
 p = (char*)(Msg+9);

 Item = new TSrchItem();

 //--- nick name
 strcpy(b, NextItem(p));
 Item->Nick = NewStr(b);

 //--- path
 strcpy(b, NextItem(p));
 Item->Path = NewStr(b);

 //--- size
 strcpy(b, NextItem(p));
 Item->Size = Str2Long(b);

 Item->Slot_Free  = 0;
 Item->Slot_Total = 0;

 //--- extract file name from full path
 poz = 0;
 poz1= 0;
 p = Item->Path;
 while (*p!='\0') {
   if (*p=='\\') poz1 = poz;
   poz++;
   p++;
 }
 Item->File = NewStr( (char*)(Item->Path+poz1+1) );

 // Check operators;
 for (i=0; i< kol_Rest->getCount(); i++) {
   TUsrItem *UItem = (TUsrItem *)kol_Rest->at(i);
   if (strcmp2(UItem->Nick,Item->Nick)==0) {
     if (UItem->Op) Item->Op=true;
     break;
   }
 }
 
 kol_Srch->insert(Item);

 ushort r = kol_Srch->getCount();
 LB_Srch->setRange(r);
 if (r>0) LB_Srch->focusItem(r-1);
     else LB_Srch->focusItem(0);
 LB_Srch->draw();
}
/*-----------------------------------------------------------------*/
void THUB::Add_Rest(int M, char *Msg)
{
     char* p;
     char  b[MAXMSG];
      int  poz, poz1;
 TUsrItem* Item;
     char  s[MAXMSG];
     char  nick[MAXMSG];
     bool  found;
   ushort  n;
   double  size;
     char  conn[MAXMSG];

 if (strlen(Msg)<10) return;
 
 p  = (char*)(Msg+9);

 //--- nick name
 strcpy2(b, NextItemSp(p));
 strcpy2(nick, b);

 //--- size of shared
 if (*p!=0) {
   strcpy2(b, NextItemSp(p));
   unsigned long long ll;
   sscanf(b,"%Lu", &ll);
   size = (double)ll/(1024*1024*1024);
   } else {
   size = 0.0;
 }

 //--- conn type
 if (*p!=0) {
   strcpy2(conn, NextItemSp(p));
   } else {
   strcpy(conn, "???");
 }
 
 ushort Count = kol_Rest->getCount();

 if ((Count==0)&&(M==3)) return;
 
 switch (M) {
   case 1:   // USER
   case 2: { // USER+
            for (n=0;n<Count;n++) {
              Item = (TUsrItem*)kol_Rest->at(n);
              if (strstr(nick, Item->Nick)==nick) return;
            }
            ChangeUser(0, 0);
            Item = new TUsrItem();
            Item->Nick  = NewStr(nick);
            Item->Share = size;
            Item->Connection = NewStr(conn);
            kol_Rest->insert(Item);
           }
           break;
   case 3: { //USER-
            found = false;
            for (n=0;n<Count;n++) {
              Item = (TUsrItem*)kol_Rest->at(n);
              if (strstr(nick, Item->Nick)==nick) {
                found = true;
                ChangeUser(3, Item->Share);
                kol_Rest->atRemove(n);
              //  if (LB_Rest->Focused>kol_Rest->Count)
                //  LB_Rest->FocusItem(0); // (n)
                n = Count + 10;
              }
            }
            if (!found) return;
           }
           break;
   case 4: {
            found = false;
            for (n=0;n<Count;n++) {
              Item = (TUsrItem*)kol_Rest->at(n);
              if (strstr(nick, Item->Nick)==nick) {
                double sh1;
                sh1 = size - Item->Share;
                found = true;
                DelStr(Item->Connection);
                Item->Connection = NewStr(conn);
                Item->Share = size;
                ChangeUser(1, sh1);
                //LB_Rest->FocusItem(n);
                n = Count + 10;
              }
            }
            if (!found) {
              Item = new TUsrItem();
              Item->Nick  = NewStr(nick);
              Item->Share = size;
              Item->Connection = NewStr(conn);
              ChangeUser(2, size);
              kol_Rest->insert(Item);
              //LB_Rest->FocusItem(kol_Rest->Count-1);
            }
           }
           break;
 }

 LB_Rest->setRange(kol_Rest->getCount());
 LB_Rest->draw();
}
/*-----------------------------------------------------------------*/
void THUB::Add_VAR(char *Msg)
{
 char *p;
 bool ok = false;
 char s[MAXMSG];

 p = (char*)(Msg+9);
 
 if (strstr(p,"ddl")!=NULL) ok=true;
 if (!ok) if (strstr(p,"md5sum")!=NULL) ok=true;
 if (!ok) if (strstr(p,"behind")!=NULL) ok=true;

 if (!ok) return;

 sprintf(s," STATUS> %s", p);
 DOther->AddMessage(s, false);
}
/*-----------------------------------------------------------------*/
void THUB::SendMsg(char* Msg)
{
 Socket->Write(Msg);
}
/*------------------------------------------------------------------*/
void THUB::UINFO()
{
 for (ushort i=0; i<kol_Rest->getCount(); i++) {
   TUsrItem* I = (TUsrItem *)kol_Rest->at(i);
   if ( I->Share == 0.0 ) {
     sprintf(command, "/UINFO %s\n", I->Nick);
     Socket->Write(command);
   }
 }
}
/*------------------------------------------------------------------*/
void THUB::ChangeUser(int M, double Shared)
{
 switch (M) {
   case 0: Total_Users++;
           break;
   case 1: Total_Shared += Shared/1024;
           break;
   case 2: Total_Users++;
           Total_Shared += Shared/1024;
           break;
   case 3: Total_Users--;
           Total_Shared -= Shared/1024;
           break;
 }
 char b[128];
 sprintf(b, "Users: %-4d Shared %7.2lfTB", Total_Users, Total_Shared);
 UsersST->setText(b);
}
/*------------------------------------------------------------------*/
ushort THUB::LunchWnd(TDialog* Wnd)
{
 ushort ret;
 if (DCApp->validView(Wnd)) {
   ret = DCApp->deskTop->execView(Wnd);
   } else {
   return cmCancel;
 }
 return ret;
}
/*------------------------------------------------------------------*/
bool THUB::EnterHandle()
{
 if (current==CHAT) {
   char c[101];
   CHAT->getData(c);
   if (c[0]!='\0') {
     sprintf(command,"/CHAT %s\n", c);
     SendMsg(command);
     memset(c,0x0,sizeof(c));
     CHAT->setData(c);
   }
   return true;
 }

 if (current==SIL) {
   Search();
   return true;
 }

 if (current == LB_Srch) {
   if (kol_Srch->getCount()==0) return true;
   LB_Srch->getData(&dkol_Srch);
   TSrchItem* I = (TSrchItem *)kol_Srch->at(dkol_Srch.selection);
   TGDLItem* GI;
   double    gdlsize;
   char s1[256];
   if (kol_GDL->getCount()!=0) {
     LB_GDL->getData(&dkol_GDL);
     GI = (TGDLItem*)kol_GDL->at(dkol_GDL.selection);
     strcpy2(s1, GI->FileName);
     gdlsize = GI->Size;
     } else {
     s1[0]='\0';
     gdlsize = 0.0;
   }
   DSInfo = new TSInfoDial(TRect(0,0,80,17)," File details ", this, I, s1, gdlsize);
   ushort ret;
   bool   AS;
   ret = LunchWnd(DSInfo);
   AS  = DSInfo->AS;
   destroy(DSInfo);
   switch (ret) {
     case cmOK:  GDL->Download(I);        break;
     case cmYes: if (AS) {
                   GDL->AutoSearch(I, GI);
                   } else {
                   GDL->DownloadSrc(I, GI);
                 }
                 break;
     case cmNo:  char n[81];
                 strcpy2(n,I->Nick);
                 UserFileList(n);
                 break;
     //default:    return true;
   }
   GetGDLList();
   return true;
 }

 if (current == LB_Rest) {
   if (kol_Rest->getCount()==0) return true;
   LB_Rest->getData(&dkol_Rest);
   TUsrItem* I = (TUsrItem *)kol_Rest->at(dkol_Rest.selection);
   if (messageBox("^cQuery for user files ?", mfConfirmation|mfYesButton|mfNoButton) == cmYes ) {
     UserFileList(I->Nick);
     } else {
     DPChat->SetNick(I->Nick);
     LunchWnd(DPChat);
   }
   return true;
 }

 if (current == LB_GDL) {
   //clearEvent(event);
   if (kol_GDL->getCount()==0) return true;
   LB_GDL->getData(&dkol_GDL);
   ushort ret=GDL->ShowDialog(dkol_GDL.selection);
   if (ret==cmOK) {
     GetGDLList();
   }
 }
 
 return false;
}
/*------------------------------------------------------------------*/
void THUB::UserFileList(char* ANick)
{
 kol_Srch            = new TObjCollection(10,10);
 dkol_Srch.items     = kol_Srch;
 dkol_Srch.selection = 0;
 LB_Srch->setData(&dkol_Srch);
 LB_Srch->setRange(0);
 LB_Srch->focusItem(0);

 sprintf(command, "/LS %s\n", ANick);
 SendMsg(command);
 sprintf(command, "CLIENT> USER FILE LIST (nick: %s )", ANick);
 DOther->AddMessage(command, false);
}
/*------------------------------------------------------------------*/
void THUB::GetGDLList()
{
 kol_GDL            = GDL->Build();
 dkol_GDL.items     = kol_GDL;
 dkol_GDL.selection = 0;
 LB_GDL->setData(&dkol_GDL);

 sprintf(command, "/GDLQLST\n");
 SendMsg(command);
}
/*------------------------------------------------------------------*/
void THUB::Command()
{
 DComm = new TCommDial(TRect(0,1,80,6),"RAW command to dctc", this);

 if (LunchWnd(DComm)==cmOK) {
   if (DComm->C[0]!='\0') {
     sprintf(command,"%s\n", DComm->C);
     SendMsg(command);
   }
 }
 destroy(DComm);
}
/*------------------------------------------------------------------*/
void THUB::Extra()
{
 DExtra = new TExtraDial(TRect(0,1,80,9)," Special commands ", this);

 if (LunchWnd(DExtra)==cmOK) {
   ushort u;
   DExtra->getData(&u);
   switch (u) {
     case 0: if (kol_Rest->getCount()>0) {
                 UINFO();
             }
             break;
     case 1: sprintf(command, "/AWAY\n");  SendMsg(command); break;
     case 2: sprintf(command, "/HERE\n");  SendMsg(command); break;
     case 3: sprintf(command, "/LINK\n");  SendMsg(command); break;
     case 4: sprintf(command, "/NOLINK\n");SendMsg(command); break;
   }
 }
 destroy(DExtra);
}
/*------------------------------------------------------------------*/




/*------------------------------------------------------------------*/
//class TSrchListBox : public TListBox
/*------------------------------------------------------------------*/
TSrchListBox::TSrchListBox(TRect AR, ushort AC, TScrollBar* SB)
             :TListBox(AR, AC, SB)
{
}
/*------------------------------------------------------------------*/
void TSrchListBox::shutDown()
{
 TListBox::shutDown();
}
/*------------------------------------------------------------------*/
void TSrchListBox::getText(char* dest, ccIndex item, short maxLen)
{
 TSrchItem* I;
    double  d;
      char  s[256];
      char  u[51];
      char  n[51];
      
 I = (TSrchItem*)items->at(item);

 d = (double)(I->Size/(1024*1024));
 strcpy(n, I->Nick);
 if (strlen(n)>12) n[12]='\0';
 sprintf(u,"%s [%d/%d]", n,I->Slot_Free,I->Slot_Total);
 
 sprintf(s,"%-19s%c%7.2lfMB%c%s", u, columnSeparator,
                                  d, columnSeparator,
                                  I->File);
 if (I->Op) {
   s[15]='[';
   s[16]='O';
   s[17]='P';
   s[18]=']';
 }

 s[(maxLen<256?maxLen:256)]='\0';
 strncpy(dest,s,maxLen);
}
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/
//                class TUsrItem : public TObject
/*-----------------------------------------------------------------*/
TUsrItem::TUsrItem():TObject()
{
 Nick       = NULL;
 Connection = NULL;
 Share      = 0.0;
 Op         = false;
}
/*-----------------------------------------------------------------*/
void TUsrItem::shutDown()
{
 DelStr(Nick);
 DelStr(Connection);
 TObject::shutDown();
}
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
//class TUsrListBox : public TListBox
/*-----------------------------------------------------------------*/
TUsrListBox::TUsrListBox(TRect AR, ushort AC, TScrollBar* SB)
            :TListBox(AR, AC, SB)
{
}
/*-----------------------------------------------------------------*/
void TUsrListBox::shutDown()
{
 TListBox::shutDown();
}
/*-----------------------------------------------------------------*/
void TUsrListBox::getText(char* dest, ccIndex item, short maxLen)
{
 TUsrItem* I;
     char  s[128];
     char  u[51];
     char  n[51];
     
 I = (TUsrItem*)items->at(item);

 strcpy(n, I->Nick);
 if (strlen(n)>18) n[18]='\0';
 sprintf(s,"%-18s %7.2lfGB %s", n, I->Share, I->Connection);

 if (I->Op) {
   s[14]='[';
   s[15]='O';
   s[16]='P';
   s[17]=']';
 }

 s[(maxLen<128?maxLen:128)]='\0';
 strcpy(dest, s);
}
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
//class TGDLListBox : public TListBox
/*-----------------------------------------------------------------*/
TGDLListBox::TGDLListBox(TRect AR, ushort AC, TScrollBar* SB)
            :TListBox(AR,AC,SB)
{
}
/*-----------------------------------------------------------------*/
void TGDLListBox::shutDown()
{
 TListBox::shutDown();
}
/*-----------------------------------------------------------------*/
void TGDLListBox::getText(char* dest, ccIndex item, short maxLen)
{
 TGDLItem* I;
     char  s[256];
     char  a[7];

 I = (TGDLItem*)items->at(item);

 if (I->Attach) strcpy(a,"Active");
          else  strcpy(a,"Holded");

 sprintf(s,"%s%c%s", a, columnSeparator, I->FileName);

 s[(maxLen<256?maxLen:256)]='\0';
 strcpy(dest,s);
}
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
// class TUsrColl : public TSortedCollection
/*-----------------------------------------------------------------*/
TUsrColl::TUsrColl(ccIndex aLimit, ccIndex aDelta)
         :TSortedCollection(aLimit, aDelta)
{
}
/*-----------------------------------------------------------------*/
void TUsrColl::shutDown()
{
 TSortedCollection::shutDown();
}
/*-----------------------------------------------------------------*/
int TUsrColl::compare(void* key1, void* key2)
{
 TUsrItem* I1 = (TUsrItem *)key1;
 TUsrItem* I2 = (TUsrItem *)key2;
 int       ret;

 ret = strcasecmp(I1->Nick, I2->Nick);
 if (ret<0) return -1;
 if (ret>0) return +1;
 return 0;
}
/*-----------------------------------------------------------------*/
void* TUsrColl::readItem( ipstream& )
{
 return NULL;
}
/*-----------------------------------------------------------------*/
void TUsrColl::writeItem( void *, opstream& )
{
}
/*-----------------------------------------------------------------*/

