/*
 * LDCC - a Linux Direct Connect Client
 * Copyright (C) 2003 Marcin Slonicki
 *
 * search.h: Copyright (C) Marcin Slonicki <marcins@softservice.com.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __SEARCH_H
#define __SEARCH_H
/*-----------------------------------------------------------------*/
#define Uses_TListBox
#define Uses_TDialog
#define Uses_TLabel
#include <tv.h>

#include "d_error.h"
#include "progress.h"
#include "gdl.h"
/*-----------------------------------------------------------------*/
#define MAX_HUB_TABLE 10
/*-----------------------------------------------------------------*/
extern char LastSearch[128];
/*-----------------------------------------------------------------*/
class TSrchListBox : public TListBox
{
 public:
                        TSrchListBox(TRect AR, ushort AC, TScrollBar* SB);
                   void shutDown();
                   void getText(char* dest, ccIndex item, short maxLen);
                   // void drawView();
};
/*-----------------------------------------------------------------*/
class TUsrColl : public TSortedCollection
{
 public:
                TUsrColl(ccIndex aLimit, ccIndex aDelta);
           void shutDown();
           int  compare(void* key1, void* key2);
 private:
          void* readItem( ipstream& );
          void  writeItem( void *, opstream& );
};
/*-----------------------------------------------------------------*/
class TUsrItem : public TObject
{
 public:
                TUsrItem();
           void shutDown();

             char* Nick;
           double  Share;
             char* Connection;
             bool  Op;
};
/*-----------------------------------------------------------------*/
class TUsrListBox : public TListBox
{
 public:
                        TUsrListBox(TRect AR, ushort AC, TScrollBar* SB);
                   void shutDown();
                   void getText(char* dest, ccIndex item, short maxLen);
                   // void drawView();
};
/*-----------------------------------------------------------------*/
class TGDLListBox : public TListBox
{
 public:
                        TGDLListBox(TRect AR, ushort AC, TScrollBar* SB);
                   void shutDown();
                   void getText(char* dest, ccIndex item, short maxLen);
};
/*-----------------------------------------------------------------*/
enum TWndMode {wmNormal,wmZoom};

class THUB : public TDialog
{
 public:
                THUB(TRect AR, char* ATitle, char* AAddr, uchar amyNo);
           void shutDown();
           void handleEvent(TEvent& event);
           void sizeLimits(TPoint& min, TPoint& max);
           void idle();

           bool Connect(bool newHub);
            int CheckNewHub();
           void Disconnect();
           void Read();
           void Search();
           void UserFileList(char* ANick);
           void ChangeUser(int M, double Shared);

           void Add_Msg(int M, char* Msg);
           void Add_Srch(char* Msg);
           void Add_LS(char* Msg);
           void Add_Rest(int M, char* Msg);
           void Add_VAR(char* Msg);
           void Add_Xfer(int M, char* Msg);
           void Add_Op(char* Msg);

           void SendMsg(char* Msg);

         ushort LunchWnd(TDialog* Wnd);
           bool EnterHandle();
           void PrivMessage(char* Msg);
           void GetGDLList();
           void Command();
           void Extra();
           void UINFO();

           void ChangeMode();

 private:
                 TWndMode  wndMode;
                    uchar  myNo;
                    
               TErrorDial* DError;       // Okienka
                TAutoDial* DAuto;
               TOtherDial* DOther;
               TSInfoDial* DSInfo;
               TPChatDial* DPChat;
                TCommDial* DComm;
               TExtraDial* DExtra;
             TAdvSrchDial* DAdvSrch;
             TProgBarDial* DProgBar;

                     TGDL* GDL; // GDL Object
             
                 TListBox* LB_Msg;
      TNSStringCollection* kol_Msg;
              TListBoxRec  dkol_Msg;

               TInputLine* CHAT; // Main chat InputLine
               TInputLine* SIL;  // Search InputLine
                   TLabel* SL;   // Search InputLine Label
             TSrchListBox* LB_Srch;
           TObjCollection* kol_Srch;
              TListBoxRec  dkol_Srch;

              TUsrListBox* LB_Rest;
                 TUsrColl* kol_Rest;
              TListBoxRec  dkol_Rest;

              TGDLListBox* LB_GDL;
           TObjCollection* kol_GDL;
              TListBoxRec  dkol_GDL;
            
                  TSocket* Socket;
                     bool  connected;
  
//                      int  num_dctc_clients;
//                      int  dctc_srv_index;
//                     char  dctc_clients[128][128];
//                     char  dctc_server_name[MAXMSG];

                     char* Addr;
                     char* dctc_path;
                     char  command[MAXMSG];
                  // char* Users;
            TMyStaticText* UsersST;
                   ushort  Total_Users;
                   double  Total_Shared;
                     
//        void fill_running_hub_list(char *s);
};
/*-----------------------------------------------------------------*/
void InsertHUB(char *ATitle, char *Addr, bool newHub);

struct THUB_TABLE {
  uchar  No;
   THUB* Dialog;
   };

extern THUB_TABLE HUB_TABLE[MAX_HUB_TABLE];
/*-----------------------------------------------------------------*/
#endif

